unit UReqDialog;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons,Udefinitions, ComCtrls, ExtCtrls,StrUtils;

type
  TFormReqDialog = class(TForm)
    GroupBox2: TGroupBox;
    BYesToAll: TSpeedButton;
    BYes: TButton;
    GroupBox1: TGroupBox;
    BRenAO: TSpeedButton;
    BRenAN: TSpeedButton;
    BRenN: TSpeedButton;
    BRenO: TSpeedButton;
    GroupBox3: TGroupBox;
    PProp: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    ESizeOld: TEdit;
    ETCreateOld: TEdit;
    ETAccessOld: TEdit;
    ETWriteOld: TEdit;
    ENameOld: TEdit;
    Panel1: TPanel;
    EMess: TEdit;
    GroupBox4: TGroupBox;
    Panel2: TPanel;
    Label3: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    ESizeNew: TEdit;
    ETCreateNew: TEdit;
    ETAccessNew: TEdit;
    ETWriteNew: TEdit;
    ENameNew: TEdit;
    LVAttrNew: TListView;
    LVAttrOld: TListView;
    GroupBox5: TGroupBox;
    BNoToAll: TSpeedButton;
    BNo: TButton;
    BBreak: TButton;
    BSuspend: TButton;
    procedure BYesClick(Sender: TObject);
    procedure BNoToAllClick(Sender: TObject);
    procedure BYesToAllClick(Sender: TObject);
    procedure BRenNClick(Sender: TObject);
    procedure BRenOClick(Sender: TObject);
    procedure BRenANClick(Sender: TObject);
    procedure BRenAOClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BNoClick(Sender: TObject);
    procedure BBreakClick(Sender: TObject);
    procedure BSuspendClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    dialbutton: integer;
    Execute: boolean;
    rj: RJob;
    CV: CompData;
    rr: IDRec;
    procedure RenProc(button: cardinal);
  end;

var
  FormReqDialog: TFormReqDialog;

implementation

uses Uglobal;


{$R *.dfm}

procedure TFormReqDialog.BYesClick(Sender: TObject);
begin
dialbutton:=bmYes;
Execute:=true;
Close;
end;

procedure TFormReqDialog.BNoToAllClick(Sender: TObject);
begin
dialbutton:=bmNoToAll;
Execute:=true;
Close;
end;

procedure TFormReqDialog.BYesToAllClick(Sender: TObject);
begin
dialbutton:=bmYesToAll;
Execute:=true;
Close;
end;

procedure TFormReqDialog.BRenNClick(Sender: TObject);
begin
RenProc(bmRenNew);
end;

procedure TFormReqDialog.BRenOClick(Sender: TObject);
begin
RenProc(bmRenOld);
end;

procedure TFormReqDialog.BRenANClick(Sender: TObject);
begin
RenProc(bmRenAllNew);
end;

procedure TFormReqDialog.BRenAOClick(Sender: TObject);
begin
RenProc(bmRenAllOld);
end;

procedure TFormReqDialog.FormCreate(Sender: TObject);
begin
Execute:=false;
dialbutton:=bmNoButtons;
end;

procedure TFormReqDialog.FormShow(Sender: TObject);
begin
try
EMess.Text:=rj.RDR.mess;
ENameNew.Text:=AnsiReplaceText(rj.RDR.dfrom+'\'+rj.RDR.fname,'\\','\');
ENameOld.Text:=AnsiReplaceText(rj.RDR.dto+'\'+rj.RDR.fname,'\\','\');

CV:=CompData(rj.RDR.pCompData);
rr:=CV.idd;
ETCreateNew.Text:=DateTimeToStr(rr.timecreate);
ETAccessNew.Text:=DateTimeToStr(rr.timeaccess);
ETWriteNew.Text:=DateTimeToStr(rr.timewrite);
ESizeNew.Text:=SizeString(rr.isize)+'  ( '+ FormatNumber(FloatToStr(rr.isize))+' bytes )';
  if((rr.iattr and faReadOnly)<> 0)then LVAttrNew.Items.Item[0].Checked:=true else
  LVAttrNew.Items.Item[0].Checked:=false;
  if((rr.iattr and faHidden)<> 0)then LVAttrNew.Items.Item[1].Checked:=true else
  LVAttrNew.Items.Item[1].Checked:=false;
  if((rr.iattr and faSysFile)<> 0)then LVAttrNew.Items.Item[2].Checked:=true else
  LVAttrNew.Items.Item[2].Checked:=false;
  if((rr.iattr and faVolumeID)<> 0)then LVAttrNew.Items.Item[3].Checked:=true else
  LVAttrNew.Items.Item[3].Checked:=false;
  if((rr.iattr and faDirectory)<> 0)then LVAttrNew.Items.Item[4].Checked:=true else
  LVAttrNew.Items.Item[4].Checked:=false;
  if((rr.iattr and faArchive)<> 0)then LVAttrNew.Items.Item[5].Checked:=true else
  LVAttrNew.Items.Item[5].Checked:=false;

rr:=IDRec(rj.RDR.pIDRec);
ETCreateOld.Text:=DateTimeToStr(rr.timecreate);
ETAccessOld.Text:=DateTimeToStr(rr.timeaccess);
ETWriteOld.Text:=DateTimeToStr(rr.timewrite);
ESizeOld.Text:=SizeString(rr.isize)+'  ( '+ FormatNumber(FloatToStr(rr.isize))+' bytes )';
  if((rr.iattr and faReadOnly)<> 0)then LVAttrOld.Items.Item[0].Checked:=true else
  LVAttrOld.Items.Item[0].Checked:=false;
  if((rr.iattr and faHidden)<> 0)then LVAttrOld.Items.Item[1].Checked:=true else
  LVAttrOld.Items.Item[1].Checked:=false;
  if((rr.iattr and faSysFile)<> 0)then LVAttrOld.Items.Item[2].Checked:=true else
  LVAttrOld.Items.Item[2].Checked:=false;
  if((rr.iattr and faVolumeID)<> 0)then LVAttrOld.Items.Item[3].Checked:=true else
  LVAttrOld.Items.Item[3].Checked:=false;
  if((rr.iattr and faDirectory)<> 0)then LVAttrOld.Items.Item[4].Checked:=true else
  LVAttrOld.Items.Item[4].Checked:=false;
  if((rr.iattr and faArchive)<> 0)then LVAttrOld.Items.Item[5].Checked:=true else
  LVAttrOld.Items.Item[5].Checked:=false;
except
//
end;
end;

procedure TFormReqDialog.BNoClick(Sender: TObject);
begin
dialbutton:=bmCancel;
Execute:=true;
Close;
end;

procedure TFormReqDialog.BBreakClick(Sender: TObject);
begin
dialbutton:=bmNoToAll;
rj.babort:=true;
Execute:=true;
Close;
end;

procedure TFormReqDialog.BSuspendClick(Sender: TObject);
begin
dialbutton:=bmSuspend;
Execute:=true;
Close;
end;

procedure TFormReqDialog.RenProc(button: cardinal);
//var
//lab: string;
begin
dialbutton:=button;
 { case button of
    bmRenNew:    lab:= ENameNew.Text;
    bmRenOld:    lab:= ENameNew.Text;
    bmRenAllNew: lab:= ENameNew.Text;
    bmRenAllOld: lab:= ENameNew.Text;
  end;  }
(CompData(rj.RDR.pCompData)).idd.ilabel:=ENameOld.Text;
Execute:= InvokeRename((CompData(rj.RDR.pCompData)).idd);
Close;
end;

end.
