unit Umansync;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,ComCtrls, ExtCtrls,Buttons, ImgList, ToolWin, Udefinitions;

type
  TFormMSync = class(TForm)
    Timer1: TTimer;
    Timer2: TTimer;
    Panel2: TPanel;
    PB: TProgressBar;
    Panel1: TPanel;
    Timer3: TTimer;
    Panel3: TPanel;
    SBLock: TSpeedButton;
    SBAbort: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Panel1Click(Sender: TObject);
    procedure Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure SBAbortClick(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure Panel1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBLockClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    hhide: boolean;
    rr: RJob;
    mssign,msleft,delta: integer;
  end;
var
  FormMSync: TFormMSync;
  hhh: integer;
  lockclicked: boolean;
implementation

uses Usync, Ugrsync;

{$R *.dfm}

procedure TFormMSync.FormCreate(Sender: TObject);
begin
mssign:=1;
Left:=Screen.Width;
hhide:=true;
lockclicked:=false;
end;

procedure TFormMSync.Timer1Timer(Sender: TObject);
var
ppp: TPoint;
begin
try
if(bShutDownAll)then
begin
Timer1.Enabled:=false;
exit;
end;
windows.GetCursorPos(ppp);
if(rr.complete)then PB.Position:=0;
if((ppp.X<Left)or(ppp.Y<Top)or(ppp.Y>(Top+Height))or(ppp.X>(Left+Width)))then
begin
  if((not hhide)and(Gstartlabels))then
  begin
  Timer2.Enabled:=true;
  end;
end;
except
//
end;
end;

procedure TFormMSync.Timer2Timer(Sender: TObject);
begin
try
if(bShutDownAll)then
begin
Timer2.Enabled:=false;
exit;
end;
if(not SBLock.Down)then
begin
  if(((Left<Screen.Width)and(mssign = 1))or((Left>(-self.Width))and(mssign = -1)))then
  begin
    Left:=Left+delta*mssign
  end else
  begin
    Timer2.Enabled:=false;
    hhide:=true;
    self.Visible:=false;
    lockclicked:=false;
  end;
end;
except
//
end;
end;

procedure TFormMSync.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
Timer2.Enabled:=false;
Left:=msleft;
end;

procedure TFormMSync.Panel1Click(Sender: TObject);
begin
try
if(Panel1.Color <> clFuchsia)then
begin
rr.starter:=spManual;
self.rr.SyncHide;
Timer3.Enabled:=true;
Panel1.Color:=clFuchsia;
end;
except
//
end;
end;

procedure TFormMSync.Panel1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
Timer2.Enabled:=false;
Left:=msleft;
end;

procedure TFormMSync.SBAbortClick(Sender: TObject);
begin
try
if(rr.pabort<>nil)then
rr.pabort^:=true;
except
//
end;
end;

procedure TFormMSync.Timer3Timer(Sender: TObject);
begin
try
if(bShutDownAll)then
begin
Timer3.Enabled:=false;
exit;
end;
PB.Max:=rr.maxval;
PB.Position:=rr.position;
if(rr.complete)then
begin
Panel1.Color:=clBtnFace;
Timer3.Enabled:=false;
end;
except
//
end;
end;

procedure TFormMSync.Panel1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
Panel1.Color:=clYellow;
end;

procedure TFormMSync.SBLockClick(Sender: TObject);
begin
if(not SBLock.Down)then
begin
//Timer2.Enabled:=true;
lockclicked:=true;
end;
end;

end.
