unit Unethood;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Spin, StdCtrls, ComCtrls,Udefinitions,Ftp, ExtCtrls, FTPSock,
  Buttons;

type
  TFormNetHood = class(TForm)
    PageControl2: TPageControl;
    TSFTP: TTabSheet;
    Label4: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    Label13: TLabel;
    EServ: TEdit;
    GroupBox1: TGroupBox;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    CBPType: TComboBox;
    EPServ: TEdit;
    EPUser: TEdit;
    EPPass: TEdit;
    SEPPort: TSpinEdit;
    EUser: TEdit;
    EPass: TEdit;
    CBPassive: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label6: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label27: TLabel;
    CBCashe: TCheckBox;
    SECasheExp: TSpinEdit;
    EFileMask: TEdit;
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    EInDir: TEdit;
    SENoopInt: TSpinEdit;
    SEPort: TSpinEdit;
    SERetries: TSpinEdit;
    SERetInt: TSpinEdit;
    CBServerType: TComboBox;
    SETimeOut: TSpinEdit;
    CBTransferMode: TComboBox;
    BBOk: TBitBtn;
    Label19: TLabel;
    EAccount: TEdit;
    CBName: TComboBox;
    CBAsynchronous: TCheckBox;
    procedure BBOkClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CBNameChange(Sender: TObject);
  private
    { Private declarations }
  public
    rj: RJobSave;
    ff: RJobSave;
    Executed: boolean;
  end;

var
  FormNetHood: TFormNetHood;

implementation

uses Uglobal;

{$R *.dfm}

procedure TFormNetHood.BBOkClick(Sender: TObject);
var
i: integer;
rs,rd: RJobSave;
begin
try
rd:=nil;
  if(CBName.Text<>'')and(Length(CBName.Text)>1)then
  begin //1
    for i:=0 to LSystem.Count-1 do
    begin
      rs:=RJobSave(LSystem.Items[i]);
      if(rs.sysname = CBName.Text)then
      begin
      rd:=rs;
      break;
      end;
    end;
    if(PageControl2.ActivePage.Name = 'TSFTP')then
    begin
      if(rd = nil)then
      begin
        New(ff);
        LSystem.Add(ff);
      end else
      ff:=rd;
      //******************************************
      ff.sysname:=CBName.Text;
      ff.jobtype:=jtRemoteFTP;
      ff.isFTP.Account:=EAccount.Text;
      ff.isFTP.Asynchronous:=CBAsynchronous.Checked;
      ff.isFTP.Cashe:=CBCashe.Checked;
      ff.isFTP.CacheExpire:=SECasheExp.Value;
      ff.isFTP.FileMask:=EFileMask.Text;
      ff.isFTP.InitialDirectory:=EInDir.Text;
      ff.isFTP.MultiThreaded:=false;
      ff.isFTP.NoopInterval:=SENoopInt.Value;
      ff.isFTP.Passive:=CBPassive.Checked;
      ff.isFTP.Password:=EPass.Text;
      ff.isFTP.Port:=SEPort.Value;
      ff.isFTP.ProxyPassword:=EPPass.Text;
      ff.isFTP.ProxyPort:=SEPPort.Value;
      ff.isFTP.ProxyServer:=EPServ.Text;
      ff.isFTP.ProxyType:=CBPType.ItemIndex;
      ff.isFTP.ProxyUser:=EPUser.Text;
      ff.isFTP.Retries:=SERetries.Value;
      ff.isFTP.RetryInterval:=SERetInt.Value;
      ff.isFTP.Server:=EServ.Text;
      ff.isFTP.ServerType:=CBServerType.ItemIndex;
      ff.isFTP.TimeOut:=SETimeout.Value;
      ff.isFTP.TransferMode:=CBTransferMode.ItemIndex;
      ff.isFTP.User:=EUser.Text;
      //******************************************
      SaveSystem(ff);
    end;
  end else
  MessageDlg(mmNameSysLen, mtInformation,[mbOk],0);
  Close;
except
//
end;
end;

procedure TFormNetHood.FormCreate(Sender: TObject);
begin
CBTransferMode.ItemIndex:=0;
CBServerType.ItemIndex:=0;
CBPType.ItemIndex:=0;
end;

procedure TFormNetHood.FormShow(Sender: TObject);
var
i,ind: integer;
rr: RJobSave;
begin
try
  ind:=-1;
  for i:=0 to LSystem.Count-1 do
  begin
    rr:=RJobSave(LSystem.Items[i]);
    CBName.Items.Add(rr.sysname);
    if(rj<>nil)and(rj = rr)then ind:=i;
  end;
  CBName.ItemIndex:=ind;
  if(rj<>nil)then
  begin
    ff:=rj;
    EAccount.Text:=ff.isFTP.Account;
    CBCashe.Checked:=ff.isFTP.Cashe;
    CBAsynchronous.Checked:=ff.isFTP.Asynchronous;
    SECasheExp.Value:=ff.isFTP.CacheExpire;
    EFileMask.Text:=ff.isFTP.FileMask;
    EInDir.Text:=ff.isFTP.InitialDirectory;
    SENoopInt.Value:=ff.isFTP.NoopInterval;
    CBPassive.Checked:=ff.isFTP.Passive;
    EPass.Text:=ff.isFTP.Password;
    SEPort.Value:=ff.isFTP.Port;
    EPPass.Text:=ff.isFTP.ProxyPassword;
    SEPPort.Value:=ff.isFTP.ProxyPort;
    EPServ.Text:=ff.isFTP.ProxyServer;
    CBPType.ItemIndex:=ff.isFTP.ProxyType;
    EPUser.Text:=ff.isFTP.ProxyUser;
    SERetries.Value:=ff.isFTP.Retries;
    SERetInt.Value:=ff.isFTP.RetryInterval;
    EServ.Text:=ff.isFTP.Server;
    CBServerType.ItemIndex:=ff.isFTP.ServerType;
    SETimeout.Value:=ff.isFTP.TimeOut;
    CBTransferMode.ItemIndex:=ff.isFTP.TransferMode;
    EUser.Text:=ff.isFTP.User;
  end;
except
//
end;
end;

procedure TFormNetHood.CBNameChange(Sender: TObject);
begin
try
if(CBName.ItemIndex = -1)then exit;
ff:=RJobSave(LSystem.Items[CBName.ItemIndex]);
EAccount.Text:=ff.isFTP.Account;
    CBCashe.Checked:=ff.isFTP.Cashe;
    CBAsynchronous.Checked:=ff.isFTP.Asynchronous;
    SECasheExp.Value:=ff.isFTP.CacheExpire;
    EFileMask.Text:=ff.isFTP.FileMask;
    EInDir.Text:=ff.isFTP.InitialDirectory;
    SENoopInt.Value:=ff.isFTP.NoopInterval;
    CBPassive.Checked:=ff.isFTP.Passive;
    EPass.Text:=ff.isFTP.Password;
    SEPort.Value:=ff.isFTP.Port;
    EPPass.Text:=ff.isFTP.ProxyPassword;
    SEPPort.Value:=ff.isFTP.ProxyPort;
    EPServ.Text:=ff.isFTP.ProxyServer;
    CBPType.ItemIndex:=ff.isFTP.ProxyType;
    EPUser.Text:=ff.isFTP.ProxyUser;
    SERetries.Value:=ff.isFTP.Retries;
    SERetInt.Value:=ff.isFTP.RetryInterval;
    EServ.Text:=ff.isFTP.Server;
    CBServerType.ItemIndex:=ff.isFTP.ServerType;
    SETimeout.Value:=ff.isFTP.TimeOut;
    CBTransferMode.ItemIndex:=ff.isFTP.TransferMode;
    EUser.Text:=ff.isFTP.User;
except
//
end;
end;

end.
