unit Unew;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,Udefinitions;

type
  TFormNew = class(TForm)
    EPath: TEdit;
    BOk: TButton;
    BCancel: TButton;
    RBFile: TRadioButton;
    RBDir: TRadioButton;
    procedure BCancelClick(Sender: TObject);
    procedure BOkClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EPathKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CBTypeKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
    rj: RJob;
  end;

var
  FormNew: TFormNew;

implementation

uses Uglobal;


{$R *.dfm}

procedure TFormNew.BCancelClick(Sender: TObject);
begin
Close;
end;

procedure TFormNew.BOkClick(Sender: TObject);
var
ext: string;
begin
  try
    if(RBFile.Checked)then
    begin
      ext:=ExtractFileExt(EPath.Text);
      if(ext = '')then EPath.Text:=ChangeFileExt(EPath.Text,'.txt');
    end;
      if(rj.ExistsS(EPath.Text,RBFile.Checked))then
      begin
      ShowMessage(mmExists);
      exit;
      end;
      rj.CreateI(EPath.Text,RBFile.Checked);
      close;

  except
    ShowMessage(GetError);
  end;
end;

procedure TFormNew.FormShow(Sender: TObject);
begin
EPath.SetFocus;
end;

procedure TFormNew.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if(Key = VK_ESCAPE)then
Close;
end;

procedure TFormNew.EPathKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if(Key = VK_ESCAPE)then
Close;
end;

procedure TFormNew.CBTypeKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if(Key = VK_ESCAPE)then
Close;
end;

end.
