unit Usync;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, StdCtrls, Buttons, ImgList,
  Menus,SyncObjs,StrUtils, Spin,Masks, Udefinitions,DateUtils, ToolWin;

  type
  SyncTh = class(TThread)
  protected
    procedure Execute; override;
  end;

type
  TForm1 = class(TForm)
    IMG2: TImageList;
    Splitter1: TSplitter;
    Timer2: TTimer;
    PopupMenu1: TPopupMenu;
    Delete1: TMenuItem;
    PageControl1: TPageControl;
    TSDir: TTabSheet;
    TSGroup: TTabSheet;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    BBDir: TBitBtn;
    GroupBox8: TGroupBox;
    LVFilters: TListView;
    GroupBox11: TGroupBox;
    EMask: TEdit;
    GroupBox12: TGroupBox;
    LVAttr: TListView;
    GroupBox13: TGroupBox;
    SBInclusive: TSpeedButton;
    SBExplore: TSpeedButton;
    LVEx: TListView;
    CBEx: TCheckBox;
    Panel3: TPanel;
    Label6: TLabel;
    Label7: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    CBSubDirs: TCheckBox;
    CBG: TComboBox;
    CBParam: TComboBox;
    CBOver: TComboBox;
    CBDir: TComboBox;
    CBRep: TComboBox;
    SERenCycle: TSpinEdit;
    Panel4: TPanel;
    GroupBox9: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    SEDay: TSpinEdit;
    SEHour: TSpinEdit;
    SEMin: TSpinEdit;
    SEDayM: TSpinEdit;
    CBEventsG: TComboBox;
    LVHist: TListView;
    Label13: TLabel;
    EGName: TEdit;
    Label14: TLabel;
    CBNotify: TCheckBox;
    StatusBar1: TStatusBar;
    ILHist: TImageList;
    ECreate: TEdit;
    Label15: TLabel;
    Label16: TLabel;
    EModify: TEdit;
    GroupBox2: TGroupBox;
    RBDays: TRadioButton;
    RBItems: TRadioButton;
    SELast: TSpinEdit;
    Label8: TLabel;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    Help1: TMenuItem;
    Help2: TMenuItem;
    About1: TMenuItem;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Edit1: TMenuItem;
    Delete2: TMenuItem;
    CBIgnoreDir: TCheckBox;
    GroupBox4: TGroupBox;
    ERenMask: TEdit;
    Panel5: TPanel;
    TVG: TTreeView;
    Panel6: TPanel;
    ToolBarSync: TToolBar;
    TBDel: TToolButton;
    ImageSyncT: TImageList;
    TBSync: TToolButton;
    TBClose: TToolButton;
    ToolBar1: TToolBar;
    TBRefreshH: TToolButton;
    TBDelSelH: TToolButton;
    TBClearH: TToolButton;
    OK1: TMenuItem;
    Synchronize2: TMenuItem;
    Exit2: TMenuItem;
    Sychronize1: TMenuItem;
    OK2: TMenuItem;
    Exit3: TMenuItem;
    CBRenAll: TCheckBox;
    TBAdd: TBitBtn;
    ED2: TComboBox;
    CBWeekD: TComboBox;
    BBEvents: TBitBtn;
    TSCase: TTabSheet;
    Panel2: TPanel;
    Label17: TLabel;
    Panel7: TPanel;
    Label20: TLabel;
    Label22: TLabel;
    CBParam1: TComboBox;
    CBDir1: TComboBox;
    CheckBox4: TCheckBox;
    GroupBox3: TGroupBox;
    ListView1: TListView;
    GroupBox5: TGroupBox;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    ListView2: TListView;
    CheckBox2: TCheckBox;
    GroupBox6: TGroupBox;
    Label19: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    SpinEdit2: TSpinEdit;
    SpinEdit3: TSpinEdit;
    SpinEdit4: TSpinEdit;
    SpinEdit5: TSpinEdit;
    SpinEdit6: TSpinEdit;
    Edit3: TEdit;
    Label18: TLabel;
    CBCaseName: TComboBox;
    Label21: TLabel;
    CBG1: TComboBox;
    Label23: TLabel;
    ComboBox1: TComboBox;
    BitBtn1: TBitBtn;
    TBMasks: TToolBar;
    TBMaster: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure BBDirClick(Sender: TObject);
    procedure SEDayChange(Sender: TObject);
    procedure SEDayWChange(Sender: TObject);
    procedure TVGClick(Sender: TObject);
    procedure SEDayMChange(Sender: TObject);
    procedure CBParamChange(Sender: TObject);
    procedure CBDirChange(Sender: TObject);
    procedure TVGGetImageIndex(Sender: TObject; Node: TTreeNode);
    procedure SBInclusiveClick(Sender: TObject);
    procedure TVGEdited(Sender: TObject; Node: TTreeNode; var S: String);
    procedure Timer2Timer(Sender: TObject);
    procedure SBExploreClick(Sender: TObject);
    procedure TVGDblClick(Sender: TObject);
    procedure CBNotifyClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure TBAddClick(Sender: TObject);
    procedure TBSyncClick(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure TBRefreshHClick(Sender: TObject);
    procedure TBDelSelHClick(Sender: TObject);
    procedure TBClearHClick(Sender: TObject);
    procedure ERenMaskKeyPress(Sender: TObject; var Key: Char);
    procedure CBWeekDChange(Sender: TObject);
    procedure BBEventsClick(Sender: TObject);
    procedure Help2Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure TVGExpanding(Sender: TObject; Node: TTreeNode;
      var AllowExpansion: Boolean);
    procedure TVGCollapsing(Sender: TObject; Node: TTreeNode;
      var AllowCollapse: Boolean);
    procedure CBCaseNameKeyPress(Sender: TObject; var Key: Char);
    procedure TBMasterClick(Sender: TObject);
  private
    { Private declarations }
    procedure WMSysCommand(var Msg: TWMSysCommand); message WM_SYSCOMMAND;
  public
    { Public declarations }
    SelL: TRect;
    procedure SaveList;
    procedure LoadList;
    function  GetGroup(gname: string): RJob;
    procedure AddChangeProp(groupnode: TTreeNode);
    procedure AddChangePropCase(groupnode: TTreeNode);
    procedure TemplatePanel;
    procedure GroupList;
    procedure ShowProp;
    procedure RenumList(LL: TList;ttype: integer);
    procedure DrawProgress(maxval,position: integer;LL: TListItem);
    procedure ShowHist;
    procedure DelHist(delsel: boolean);
  end;

var
  Form1: TForm1;
  TM: TTimer;
  newgname: string;
  treeclick,execution,wosexecution: boolean;

implementation

uses UMain,Umansync,Ugrsync,UDirDialog,ULog,Uglobal, UEvents;
var
  CurrJob,ClickedJob: RJob;
  CurrP: DirP;
{$R *.dfm}

procedure SyncTh.Execute;
begin
  self.FreeOnTerminate:=true;
  Form1.LoadList();
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
try

LoadList;
GroupList;
except
//
end;
execution:=false;
wosexecution:=false;
CurrJob:=nil;
CurrP:=nil;
CBEventsG.ItemIndex:=0;
CBParam.ItemIndex:=0;
CBOver.ItemIndex:=0;
CBDir.ItemIndex:=0;
CBRep.ItemIndex:=0;
CBWeekD.ItemIndex:=0;
end;

procedure TForm1.SaveList;
var
i,j,k: integer;
ms: TMemoryStream;
exstr: string[250];
dp: DirP;
gg: RJob;
EL: TStringList;
dh: DirParamHist;
jh: JobHist;
jhh: JobHistory;
rr: JobRecord;
ha: HistoryAction;
hh: HistAct;
begin
try
if(not DirectoryExists(AppPath+'GroupSync'))then ForceDirectories(AppPath+'GroupSync');
ms:= TMemoryStream.Create;
try
for i:=0 to GRList.Count-1 do
begin
  gg:=RJob(GRList.Items[i]);
  Move(gg.Save,rr,sizeof(rr));
  rr.NumItems:=gg.LItems.Count;
  rr.NumHist:=gg.LHist.Count;
  rr.NumAction:=gg.LActions.Count;
  rr.successidicator:=msSuccsess;
  ms.Write(rr,sizeof(rr));
    for j:=0 to gg.LItems.Count-1 do
    begin
      dp:=DirP(gg.LItems.Items[j]);
      EL:=dp.PExList;
      dh.direct:=dp.direct;
      dh.report:=dp.report;
      dh.fparam:=dp.fparam;
      dh.over:=dp.over;
      dh.rencycle:=dp.rencycle;
      dh.fattr:=dp.fattr;
      dh.dname:=dp.dname;
      dh.groupname:=dp.groupname;
      dh.mask:=dp.mask;
      dh.renmask:=dp.renmask;
      dh.notifyfilter:=dp.notifyfilter;
      dh.maskignoredir:=dp.maskignoredir;
      dh.renameall:=dp.renameall;
      dh.successidicator:=msSuccsess;
      for k:=0 to 7 do
      dh.notfilt[k]:=dp.notfilt[k];
      for k:=0 to 6 do
      dh.fattrarr[k]:=dp.fattrarr[k];
      dh.subdirs:=dp.subdirs;
      dh.exclusive:=dp.exclusive;
      dh.notify:=dp.notify;
      dh.numExRecords:=EL.Count;
      ms.Write(dh,sizeof(dh));
      for k:=0 to EL.Count-1 do
      begin
        exstr:=EL.Strings[k];
        ms.Write(exstr,sizeof(exstr));
      end;
    end;
    //88888888888888888888888remove old history records
    ManageJobHistory(gg);
    //nn:=Now;
    //if(gg.Save.savelastdays)then nn:=IncDay(nn,(gg.Save.savelast *(-1)));

    for j:=0 to gg.LHist.Count-1 do
    begin
      jh:=JobHist(gg.LHist.Items[j]);
     { if((not gg.Save.savelastdays)and((gg.LHist.Count-j)>gg.Save.savelast))then
      begin
        Dispose(jh);
        gg.LHist.Items[j]:=nil;
        if(CurrJob = gg)then LVHist.Items.Item[j].Delete;
        continue;
      end;
      if((gg.Save.savelastdays)and(jh.jstart<nn))then
      begin
        Dispose(jh);
        gg.LHist.Items[j]:=nil;
        if(CurrJob = gg)then LVHist.Items.Item[j].Delete;
        continue;
      end; }
      jhh.jstart:=jh.jstart;
      jhh.jstop:=jh.jstop;
      jhh.jsuccess:=jh.jsuccess;
      jhh.starter:=jh.starter;
      jhh.successidicator:=msSuccsess;
      ms.Write(jhh,sizeof(jhh));
    end;
    //gg.LHist.Pack;
    //RenumList(gg.LHist,ttJobHist);

    for j:=0 to gg.LActions.Count-1 do
    begin
      hh:=HistAct(gg.LActions.Items[j]);
      Move(hh^,ha,sizeof(ha));
      ha.successidicator:=msSuccsess;
      ms.Write(ha,sizeof(ha));
    end;
    gg.SavePath:=AppPath+'GroupSync\'+gg.Save.jobname+'.syn';
    ms.SaveToFile(gg.SavePath);
    gg.changed_job:=false;
    ms.Clear;
end;
finally
ms.Free;
end;
except
//
end;
end;

procedure TForm1.LoadList;
var
TT: TTreeNode;
j,k,numb,ssize,h1: integer;
ms: TMemoryStream;
exstr: string[250];
dp: DirP;
gg: RJob;
jh: JobHist;
dg: JobRecord;
dh: DirParamHist;
hj: JobHistory;
sr: TSearchRec;
ha: HistoryAction;
hh: HistAct;
begin
try
ms:= TMemoryStream.Create;
  try
  h1:=FindFirst(AppPath+'GroupSync\*',faAnyFile,sr);
  if h1 = 0 then
  begin //2
    if((sr.Attr and faDirectory)<> 0)then
    FindNext(sr);
    while FindNext(sr) = 0 do
    begin //3
      ms.Clear;
      if(not MatchesMask(sr.Name,'*.syn'))then  continue;
      ms.LoadFromFile(AppPath+'GroupSync\'+sr.Name);
      ssize:= sizeof(dg);
      numb:=ms.Read(dg,ssize);
      if(numb = ssize)then
      begin //1
        if(dg.successidicator <> msSuccsess)then continue;
        gg:=RJob.Create;
        Move(dg,gg.Save,sizeof(dg));
        gg.listindex:=GRList.Add(gg);
        TT:=TVG.Items.Add(nil,dg.jobname);
        gg.SavePath:=AppPath+'GroupSync\'+sr.Name;
        gg.Save.jobname:=dg.jobname;
        CBG.Items.AddObject(gg.Save.jobname,gg);
        TT.Data:=gg;
        gg.trr:=TT;
        gg.PNotify:=nil;
        CheckJobSync(gg);
        for j:=0 to dg.NumItems-1 do
        begin
          if(ms.Read(dh,sizeof(dh)) = sizeof(dh))then
          begin
            if(dh.successidicator <> msSuccsess)then continue;
            New(dp);
            dp.listind:=gg.LItems.Add(dp);
            dp.direct:=dh.direct;
            dp.report:=dh.report;
            dp.fparam:=dh.fparam;
            dp.over:=dh.over;
            dp.rencycle:=dh.rencycle;
            dp.fattr:=dh.fattr;
            dp.dname:=dh.dname;
            dp.groupname:=gg.Save.jobname;
            dp.mask:=dh.mask;
            dp.renmask:=dh.renmask;
            dp.notifyfilter:=dh.notifyfilter;
            dp.subdirs:=dh.subdirs;
            dp.exclusive:=dh.exclusive;
            dp.notify:=dh.notify;
            dp.maskignoredir:=dh.maskignoredir;
            dp.renameall:=dh.renameall;
            dp.PNotify:=nil;
            //dp.rj:=gg;
            dp.rj:=nil;
            TT:=TVG.Items.AddChild(gg.trr,dp.dname);
            TT.Data:=dp;
            TT.ImageIndex:=1;
        if(Length(ExtractFileDrive(dp.dname)) > 3)then TT.ImageIndex:=4;
            TT.SelectedIndex:=3;
            for k:=0 to 7 do
            dp.notfilt[k]:=dh.notfilt[k];
            for k:=0 to 6 do
            dp.fattrarr[k]:=dh.fattrarr[k];
            dp.PExList:=TStringList.Create;
            for k:=0 to dh.numExRecords-1 do
            begin
              ms.Read(exstr,sizeof(exstr));
              dp.PExList.Add(exstr);
            end;
          end else break;
        end;
        for j:=0 to dg.NumHist-1 do
        begin
          if(ms.Read(hj,sizeof(hj)) = sizeof(hj))then
          begin
            if(hj.successidicator <> msSuccsess)then continue;
            New(jh);
            jh.jstart:=hj.jstart;
            jh.jstop:=hj.jstop;
            jh.jsuccess:=hj.jsuccess;
            jh.starter:=hj.starter;
            jh.listind:=gg.LHist.Add(jh);
          end else break;
        end;
        for j:=0 to dg.NumAction-1 do
        begin
          numb:=ms.Read(ha,sizeof(ha));
          if((numb = sizeof(ha))and(ha.successidicator = msSuccsess))then
          begin
            New(hh);
            gg.LActions.Add(hh);
            Move(ha,hh^,sizeof(ha));
          end;
        end;
      end else //1
      FormLog.RecError('Error for Read GroupSync\'+sr.Name);
      end;//3
    end; //2
  finally
  ms.Free;
  FindClose(sr);
  end;
  MainForm.BGen;
except
FormLog.RecError('1001');
end;
end;

function TForm1.GetGroup(gname: string): RJob;
var
TT,TR: TTreeNode;
i: Integer;
dd: RJob;
begin
Result:=nil;
try
TR:=nil;
dd:=nil;
if(gname<>'')then
begin
  for i:=0 to TVG.Items.Count-1 do
  begin
    TT:=TVG.Items.Item[i];
    if((TT.Text = gname)and(TT.Data<>nil)and(TT.Parent = nil))then
    begin
    TR:=TT;
    break;
    end;
  end;
  if(TR = nil)then
  begin
  TR:=TVG.Items.Add(nil,gname);
  dd:=RJob.Create;
  dd.Save.jobkind:=jkSync;
  dd.Save.jobname:=gname;
  dd.listindex:=GRList.Add(dd);
  dd.Save.tcreate:=Now;
  dd.trr:=TR;
  TR.Data:=dd;
  end else
  dd:=RJob(TR.Data);
  dd.Save.syncevent:=CBEventsG.ItemIndex;
  dd.Save.iday:=SEDay.Value;
  dd.Save.ihour:=SEHour.Value;
  dd.Save.imin:=SEMin.Value;
  dd.Save.idayw:=CBWeekD.ItemIndex;
  dd.Save.idaym:=SEDayM.Value;
  dd.Save.tchange:=Now;
  dd.Save.lasttim:=0;
  dd.Save.nexttim:=0;
  dd.Save.savelast:=SELast.Value;
  dd.Save.savelastdays:=RBDays.Checked;
  CheckJobSync(dd);
end;
SaveList;
GroupList;
Result:=dd;
except
//
end;
end;

procedure TForm1.GroupList;
var
i,j: Integer;
LL,SS: TStrings;
tr: TTreeNode;
isfind: boolean;
pp: string;
begin
try
if(TVG.Items.Count>0)then
begin
LL:=TStringList.Create;
SS:=TStringList.Create;
try
 // CBG.Items.Clear;
 pp:=ED2.Text;
 ED2.Items.Clear;
  for i:=0 to TVG.Items.Count-1 do
  begin
    tr:=TVG.Items.Item[i];
    isfind:=false;
    if(tr.Parent = nil)then
    begin
    LL.AddObject(tr.Text,RJob(tr.Data))
    end else
    begin
      if(TVG.Items.Item[i].Data<>nil)and
      (RJob(TVG.Items.Item[i].Data).Save.jobtype = jtLocal)and
      (DirectoryExists(TVG.Items.Item[i].Text))then
      TVG.Items.Item[i].ImageIndex:=1
      else
      TVG.Items.Item[i].ImageIndex:=2;
      if(Length(ExtractFileDrive(TVG.Items.Item[i].Text)) > 3)then TVG.Items.Item[i].ImageIndex:=4;
      for j:=0 to ED2.Items.Count-1 do
      if(ED2.Items.Strings[j] = tr.Text)then
      begin
      isfind:=true;
      break;
      end;
      if(not isfind)then
      ED2.Items.Add(tr.Text);
    end;
  end;
  ED2.Text:=pp;
  SS.AddStrings(CBG.Items);
  i:=0;
  while i<LL.Count do
  begin
    j:=0;
    while j<SS.Count do
    begin
      if(SS.Strings[j] = LL.Strings[i])then
      begin
      SS.Delete(j);
      LL.Delete(i);
      i:=i-1;
      break;
      end;
      j:=j+1;
    end;
    i:=i+1;
  end;
  for i:=0 to SS.Count-1 do
  begin
    j:=0;
    while j<CBG.Items.Count do
    begin
      if(CBG.Items.Strings[j] = SS.Strings[i])then
      begin
        CBG.Items.Delete(j);
        break;
      end;
      j:=j+1;
    end;
  end;
  for i:=0 to LL.Count-1 do
  CBG.Items.AddObject(LL.Strings[i],LL.Objects[i]);
finally
LL.Free;
SS.Free;
end;
end;
except
//
end;
end;


procedure TForm1.BBDirClick(Sender: TObject);
begin
ED2.Text:=InvokeDirDialog(nil);
end;

procedure TForm1.SEDayChange(Sender: TObject);
begin
CBWeekD.ItemIndex:=0;
SEDayM.Value:=0;
end;

procedure TForm1.SEDayWChange(Sender: TObject);
begin
SEDay.Value:=0;
SEDayM.Value:=0;
end;

procedure TForm1.TVGClick(Sender: TObject);
begin
try
  if(TVG.Selected<> nil)then
  begin
     if(TVG.Selected.Parent = nil)then
     ClickedJob:=RJob(TVG.Selected.Data)
     else
     ClickedJob:=RJob(TVG.Selected.Parent.Data);
     if(CurrJob <> ClickedJob)then
     begin
     LVHist.Items.Clear;
     LVEx.Items.Clear;
     CurrJob:=ClickedJob;
     ShowHist;
     end;
     ShowProp;
  end;
except
//
end;
end;

procedure TForm1.ShowHist;
var
numh: integer;
begin
try
   if(CurrJob<>nil)then
   begin
      SyncHistoryLists(CurrJob,LVHist);
      numh:=LVHist.Items.Count;
      if(numh>0)then
      DrawProgress(CurrJob.maxval,CurrJob.position,LVHist.Items.Item[numh-1]);
  end;
except
FormLog.RecError('1002');
end;
end;

procedure TForm1.ShowProp;
var
tt: TTreeNode;
dd: DirP;
gg: RJob;
i: integer;
TL: TListItem;
begin
try
  if(TVG.Selected<> nil)then
  begin
    tt:=TVG.Selected;
    if(tt.Parent <> nil)then
    begin
      PageControl1.ActivePageIndex:=0;
      dd:=DirP(tt.Data);
      CurrP:=dd;
      CBG.Text:=dd.groupname;
      ED2.Text:=dd.dname;
      CBDir.ItemIndex:=dd.direct;
      CBParam.ItemIndex:=dd.fparam;
      CBRep.ItemIndex:=dd.report;
      CBOver.ItemIndex:=dd.over;
      SERenCycle.Value:=dd.rencycle;
      EMask.Text:=dd.mask;
      ERenMask.Text:=dd.renmask;
      CBSubDirs.Checked:=dd.subdirs;
      CBNotify.Checked:=dd.notify;
      CBIgnoreDir.Checked:=dd.maskignoredir;
      CBRenAll.Checked:=dd.renameall;
      
      for i:=0 to 7 do
      LVFilters.Items.Item[i].Checked:=dd.notfilt[i];
      for i:=0 to 6 do
      LVAttr.Items.Item[i].Checked:=dd.fattrarr[i];
      TemplatePanel;

      CBEx.Checked:=dd.exclusive;
      LVEx.Items.Clear;
      if(dd.PExList<>nil)then
      for i:=0 to dd.PExList.Count-1 do
      begin
        TL:=LVEx.Items.Add;
        TL.Caption:=dd.PExList.Strings[i];
        TL.Checked:=true;
      end;
    end else
    begin
      PageControl1.ActivePageIndex:=1;
      gg:=RJob(tt.Data);
      EGName.Text:=tt.Text;
      CBEventsG.ItemIndex:=gg.Save.syncevent;
      SEDay.Value:=gg.Save.iday;
      SEHour.Value:=gg.Save.ihour;
      SEMin.Value:=gg.Save.imin;
      CBWeekD.ItemIndex:=gg.Save.idayw;
      SEDayM.Value:=gg.Save.idaym;
      ECreate.Text:=DateTimeToStr(gg.Save.tcreate);
      EModify.Text:=DateTimeToStr(gg.Save.tchange);
      SELast.Value:=gg.Save.savelast;
      RBDays.Checked:=gg.Save.savelastdays;
      RBItems.Checked:=not RBDays.Checked;
    end;
  end;
except
//
end;
end;

procedure TForm1.AddChangeProp(groupnode: TTreeNode);
var
TT,TR: TTreeNode;
i,attr: Integer;
dd: DirP;
filt: dword;
TL: TListItem;
ExList: TStringList;
GG: RJob;
isexists: boolean;
begin
TR:=groupnode;
TT:=nil;
try
if(ED2.Text<>'')then
begin
  if(TR = nil)then exit;
    if(TR.Parent = nil)then
    begin
      for i:=0 to TR.Count-1 do
      begin
        if(TR.Item[i].Text = ED2.Text)then
        begin
        TT:=TR.Item[i];
        break;
        end;
      end;
    end
    else
    TT:=TR;
    GG:=RJob(TR.Data);
    if(TT<>nil)then
    begin
      if(TT.Data = nil)then exit;
      dd:=DirP(TT.Data);
      //GG:=dd.rj;
      ExList:=dd.PExList;
    end else
    begin
      TT:=TVG.Items.AddChild(TR,ED2.Text);
      New(dd);
      dd.groupname:=TR.Text;
      TT.Data:=dd;
      ExList:=TStringList.Create;
      dd.PExList:=ExList;
      //GG:=RJob(TR.Data);
      dd.listind:=GG.LItems.Add(dd);
      dd.rj:=nil;
    end;
      CurrP:=dd;
      if(GG.Save.jobtype = jtLocal)and(not DirectoryExists(ED2.Text))then
      TT.ImageIndex:=1
      else
      TT.ImageIndex:=2;
      if(Length(ExtractFileDrive(ED2.Text)) > 3)then TT.ImageIndex:=4;
      TT.SelectedIndex:=3;
      TT.Text:=ED2.Text;
      dd.dname:=ED2.Text;
      dd.direct:=CBDir.ItemIndex;
      dd.report:=CBRep.ItemIndex;
      dd.fparam:=CBParam.ItemIndex;
      dd.over:=CBOver.ItemIndex;
      dd.notify:=CBNotify.Checked;
      dd.rencycle:=SERenCycle.Value;
      dd.subdirs:=CBSubDirs.Checked;
      dd.renmask:=ERenMask.Text;
      dd.maskignoredir:=CBIgnoreDir.Checked;
      dd.mask:=EMask.Text;
      dd.renameall:=CBRenAll.Checked;
      isexists:=false;
      //if exists a directory with notify
      for i:=0 to GG.LItems.Count-1 do
      if((DirP(GG.LItems.Items[i])).notify)then isexists:=true;
      GG.Save.notify:=isexists;
      CheckJobSync(GG);
      filt:=0;
      for i:=0 to 7 do
      begin
        dd.notfilt[i]:=false;
        if(LVFilters.Items.Item[i].Checked)then
        begin
        dd.notfilt[i]:=true;
        if(filt = 0)then filt:=NFilters[i]
        else
        filt:=filt or NFilters[i];
        end;
      end;
      dd.notifyfilter:=filt;
      attr:=0;
      for i:=0 to 6 do
      begin
        dd.fattrarr[i]:=false;
        if(LVAttr.Items.Item[i].Checked)then
        begin
        dd.fattrarr[i]:=true;
        attr:=attr or FileAttr[i];
        end;
      end;
      if(attr = 0)then
      begin
        dd.fattrarr[6]:=true;
        attr:=attr or FileAttr[6];
      end;
      dd.fattr:=attr;
      dd.exclusive:=CBEx.Checked;
      ExList.Clear;
      if(CBEx.Checked)then
      begin
        if(ExList<>nil)then
        for i:=0 to LVEx.Items.Count-1 do
        begin
          TL:=LVEx.Items.Item[i];
          if(TL.Checked)then
          ExList.Add(TL.Caption);
        end;
      end;
end;
SaveList;
except
FormLog.RecError('1003');
end;
end;

procedure TForm1.SEDayMChange(Sender: TObject);
begin
CBWeekD.ItemIndex:=0;
SEDay.Value:=0;
end;

procedure TForm1.CBParamChange(Sender: TObject);
begin
TemplatePanel;
end;

procedure TForm1.TemplatePanel;
var
i: integer;
begin
try
if(CBNotify.Checked)then
begin
GroupBox8.Enabled:=true;
GroupBox8.Font.Color:=clWindowText;
end else
begin
GroupBox8.Enabled:=false;
GroupBox8.Font.Color:=clInactiveCaption;
for i:=0 to 7 do
LVFilters.Items.Item[i].Checked:=false;
end;

if(CBOver.ItemIndex = (opRenCycle))then begin
SERenCycle.Enabled:=true;
SERenCycle.Font.Color:=clWindowText;
end else begin
SERenCycle.Enabled:=false;
SERenCycle.Font.Color:=clInactiveCaption;
end;

  if(CBParam.ItemIndex = fpMaster)then
  begin
   CBDir.ItemIndex:=dpOut;
   CBDir.Enabled:=false;
   CBOver.Enabled:=true;
  end else
  if(CBParam.ItemIndex = fpSlave)then
  begin
   CBDir.ItemIndex:=dpIn;
   CBDir.Enabled:=false;
   CBOver.Enabled:=false;
  end else
  if(CBParam.ItemIndex = fpEmpty)then
  begin
   CBDir.ItemIndex:=dpInOut;
   //CBDir.Enabled:=false;
   CBOver.Enabled:=false;
  end else
  if(CBParam.ItemIndex = fpRename)then
  begin
    CBDir.ItemIndex:=dpOut;
    CBDir.Enabled:=false;
    CBOver.Enabled:=false;
    CBSubDirs.Checked:=false;
    CBSubDirs.Enabled:=false;
    CBRenAll.Checked:=true;
    //CBRenAll.Enabled:=false;
  end else
  if(CBParam.ItemIndex = fpLastChanges)then
  begin
    CBDir.ItemIndex:=dpIn;
    CBDir.Enabled:=false;
  end else
  if(CBParam.ItemIndex = fpSmartSlave)then
  begin
    CBDir.ItemIndex:=dpInOut;
    CBDir.Enabled:=false;
    CBOver.Enabled:=false;
  end else
  begin
    CBDir.Enabled:=true;
    CBOver.Enabled:=true;
    CBSubDirs.Enabled:=true;
    //CBRenAll.Enabled:=true;
  end;
except
//
end;
end;


procedure TForm1.CBDirChange(Sender: TObject);
begin
TemplatePanel;
end;

procedure TForm1.TVGGetImageIndex(Sender: TObject; Node: TTreeNode);
begin
try
if(Node.Parent <> nil)then
begin
  if(Length(ExtractFileDrive(Node.Text)) = 3)then
  begin
    if(DirectoryExists(Node.Text))then
    Node.ImageIndex:=2
    else
    Node.ImageIndex:=1;
  end else
  Node.ImageIndex:=4;
  //windows.Beep(1000,300);
end else
Node.ImageIndex:=0;
except
//
end;
end;


procedure TForm1.SBInclusiveClick(Sender: TObject);
var
i: integer;
begin
try
for i:=0 to LVEx.Items.Count-1 do
LVEx.Items.Item[i].Checked:= not LVEx.Items.Item[i].Checked;
except
//
end;
end;

procedure TForm1.TVGEdited(Sender: TObject; Node: TTreeNode;
  var S: String);
var
i: integer;
tt: TTreeNode;
dd: DirP;
mm: RJob;
begin
try
  if(Node.Parent = nil)then
  begin
    mm:=RJob(Node.Data);
    if(mm<>nil)then mm.Save.jobname:=S;
    for i:=0 to Node.Count-1 do
    begin
      tt:=Node.Item[i];
      if(tt.Data<>nil)then
      begin
      dd:=DirP(tt.Data);
      dd.groupname:=S;
      end;
    end;
    newgname:=S;
    Timer2.Enabled:=true;
  end else
  begin
    //if(LastDelimiter('\',S)<Length(S))then S:=S+'\';
    if(Node.Data<>nil)then
    begin
    dd:=DirP(Node.Data);
    dd.dname:=S;
    if(ED2.Text = Node.Text)then
    ED2.Text:=S;
    end;
  end;
SaveList;
except
//
end;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
var
i,count: integer;
begin
if(bShutDownAll)then
begin
Timer2.Enabled:=false;
exit;
end;
self.Caption:=fcSync+ContextMenuClic;
try
 if(CurrJob<>nil)then
 begin
 DrawCurrent(TVG,SelL);
 if(CurrJob.changed_job)then
 begin
  SaveList;
  CurrJob.changed_job:=false;
 end;
 end;
if(LVEx.Tag = 1)then
begin
  if(TempJobList<>nil)then
  while TempJobList.Count>0 do
  begin
    RJob(TempJobList.Items[0]).Free;
    TempJobList.Delete(0);
  end;
  LVEx.Tag:=0;
end;
  ShowHist;
  if(execution)then
  begin
  count:=0;
  for i:=0 to GRList.Count-1 do
  if(not RJob(GRList.Items[i]).complete)then  count:=count+1;
  if(count=0)then wosexecution:=true;
  end;
  if(execution and wosexecution)then
  begin
    execution:=false;
    wosexecution:=false;
    SaveList;
  end;
except
FormLog.RecError('0001'+ mmFatalError);
Timer2.Enabled:=false;
end;
end;

procedure TForm1.DrawProgress(maxval,position: integer;LL: TListItem);
var
irr: TRect;
maxr: integer;
cpen,cbrush: TColor;
begin
try
  irr:=LL.DisplayRect(drBounds);
  irr.Left:=irr.Left+LVHist.Columns.Items[0].Width+
  LVHist.Columns.Items[1].Width+LVHist.Columns.Items[2].Width+
  LVHist.Columns.Items[3].Width+LVHist.Columns.Items[4].Width+3;
  irr.Top:=irr.Top+2;
  irr.Bottom:=irr.Bottom-3;
  irr.Right:=irr.Right-3;
  
  cpen:=LVHist.Canvas.Pen.Color;
  cbrush:=LVHist.Canvas.Brush.Color;
  if(position>0)then
  begin
  maxr:=irr.Right;
  LVHist.Canvas.Brush.Color:=clYellow;
  LVHist.Canvas.Rectangle(irr);
  LVHist.Canvas.Brush.Color:=clBlue;
  irr.Right:=irr.Left + Round(((irr.Right-irr.Left)/maxval)*position);
  if(irr.Right>maxr)then irr.Right:=irr.Left;
  LVHist.Canvas.Rectangle(irr);
  end else
  begin
  LVHist.Canvas.Pen.Color:=cbrush;
  LVHist.Canvas.Brush.Color:=cbrush;
  LVHist.Canvas.Rectangle(irr);
  end;
  LVHist.Canvas.Pen.Color:=cpen;
  LVHist.Canvas.Brush.Color:=cbrush;
except
//
end;
end;


procedure TForm1.SBExploreClick(Sender: TObject);
var
jj: RJob;
begin
try
  if(CurrJob = nil)then exit;
  jj:=CheckJob(CurrP.dname,CurrJob,nil,CurrP,nil,TempJobList);
  jj.PrepareEx(ED2.Text,LVEx,LVAttr,EMask.Text,false);
except
//
end;
end;

procedure TForm1.TVGDblClick(Sender: TObject);
begin
try
if((TVG.Selected<> nil)and(TVG.Selected.Parent = nil))then
Sync(CurrJob);
except
//
end;
end;

procedure TForm1.RenumList(LL: TList; ttype: integer);
var
i: integer;
jh: JobHist;
dp: DirP;
rj: RJob;
begin
try
  for i:=0 to LL.Count-1 do
  begin
    case ttype of
    ttJobHist:
            begin
            jh:=JobHist(LL.Items[i]);
            jh.listind:=i;
            end;
    ttDirP:
            begin
            dp:=DirP(LL.Items[i]);
            dp.listind:=i;
            end;
    ttRJob:
            begin
            rj:=RJob(LL.Items[i]);
            rj.listindex:=i;
            end;
    end;
  end;
except
//
end;
end;

procedure TForm1.DelHist(delsel: boolean);
var
TL: TListItem;
jh: JobHist;
i: integer;
begin
try
if(delsel)then
begin
  if(LVHist.Selected<>nil)then
  begin
    TL:=LVHist.Selected;
    while TL<>nil do
    begin
      jh:=JobHist(TL.Data);
      if(CurrJob<>nil)then
      begin
        CurrJob.LHist.Delete(jh.listind);
        RenumList(CurrJob.LHist,ttJobHist);
        Dispose(jh);
      end;
      TL:=LVHist.GetNextItem(TL,sdAll,[isSelected]);
    end;
    LVHist.DeleteSelected;
  end;
end else
begin
    if(CurrJob<>nil)then
    begin
      for i:=0 to CurrJob.LHist.Count-1 do
      Dispose(CurrJob.LHist.Items[i]);
      CurrJob.LHist.Clear;
      LVHist.Items.Clear;
    end;
end;
SaveList;
except
//
end;
end;

procedure TForm1.CBNotifyClick(Sender: TObject);
begin
TemplatePanel;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
self.SetFocus;
end;

procedure TForm1.TBDelClick(Sender: TObject);
var
tt: TTreeNode;
dd: DirP;
rr: RJob;
i: integer;
begin
try
tt:=TVG.Selected;
if tt<>nil then
begin
if MessageDlg(mmAskDestroy+tt.Text+mmNode,
mtConfirmation, [mbYes, mbNo], 0) <> mrYes then exit;

ClickedJob:=nil;
CurrJob:=nil;
LVHist.Clear;
  if(tt.Parent <> nil)then
  begin
    dd:=DirP(tt.Data);
    dd.PExList.Free;
    rr:=RJob(tt.Parent.Data);
    rr.LItems.Delete(dd.listind);
    for i:=0 to rr.LItems.Count-1 do
    DirP(rr.LItems.Items[i]).listind:=i;
    dispose(dd);
    LVEx.Items.Clear;
  end else
  begin
    rr:=RJob(tt.Data);
    GRList.Delete(rr.listindex);
    if(rr.SavePath<>'')then
    DeleteFile(rr.SavePath);
    rr.Free;
  end;
  tt.Delete;
end;
ED2.Text:='';
GroupList;
SaveList;
MainForm.BGen;
TVG.Refresh;
except
//
end;
end;

procedure TForm1.TBAddClick(Sender: TObject);
var
gg: RJob;
begin
try
if(PageControl1.ActivePageIndex = 0)then
begin
gg:=GetGroup(CBG.Text);
AddChangeProp(gg.trr);
end else
if(PageControl1.ActivePageIndex = 1)then
GetGroup(EGName.Text)
else
if(PageControl1.ActivePageIndex = 2)then
begin
gg:=GetGroup(CBG.Text);
AddChangePropCase(gg.trr);
end;
MainForm.BGen;
TVG.ClearSelection();
except
//
end;
end;

procedure TForm1.TBSyncClick(Sender: TObject);
begin
try
  if(CurrJob<>nil)then
  begin
    CurrJob.starter:=spManual;
    execution:=true;
    Sync(CurrJob);
  end else
  ShowMessage(mmSyncSelGroup);
except
//
end;
end;

procedure TForm1.TBCloseClick(Sender: TObject);
begin
Close;
end;

procedure TForm1.TBRefreshHClick(Sender: TObject);
begin
ShowHist;
end;

procedure TForm1.TBDelSelHClick(Sender: TObject);
begin
if MessageDlg(mmAskDestroy+mmRecord,
mtConfirmation, [mbYes, mbNo], 0) <> mrYes then exit;
try
DelHist(true);
except
//
end;
end;

procedure TForm1.TBClearHClick(Sender: TObject);
begin
DelHist(false);
end;

procedure TForm1.ERenMaskKeyPress(Sender: TObject; var Key: Char);
begin
if(Key in NoFileNameSigns)then
begin
ShowMessage(mmFileNameSymbols);
//Key:=#0;
end;
end;

procedure TForm1.CBWeekDChange(Sender: TObject);
begin
SEDay.Value:=0;
SEDayM.Value:=0;
end;

procedure TForm1.WMSysCommand(var Msg: TWMSysCommand);
begin
if(Msg.CmdType = 61472)then Hide else inherited;
end;

procedure TForm1.BBEventsClick(Sender: TObject);
begin
if(CurrJob = nil)then exit;
try
Application.CreateForm(TFormEvents,FormEvents);
FormEvents.rj:=CurrJob;
FormEvents.ShowModal;
except
//
end;
end;

procedure TForm1.Help2Click(Sender: TObject);
begin
InvokeHelp(self.Handle,hfGrSync);
end;

procedure TForm1.About1Click(Sender: TObject);
begin
InvokeAbout;
end;

procedure TForm1.TVGExpanding(Sender: TObject; Node: TTreeNode;
  var AllowExpansion: Boolean);
begin
try
   {  if(Node.Parent = nil)then
     ClickedJob:=RJob(Node.Data)
     else
     ClickedJob:=DirP(Node.Data).rj;
     if(CurrJob <> ClickedJob)then
     LVHist.Items.Clear;
     CurrJob:=ClickedJob;
     Node.Selected:=true;     }
except
//
end;
end;

procedure TForm1.TVGCollapsing(Sender: TObject; Node: TTreeNode;
  var AllowCollapse: Boolean);
begin
try
     if(Node.Parent = nil)then
     ClickedJob:=RJob(Node.Data)
     else
     ClickedJob:=DirP(Node.Data).rj;
     if(CurrJob <> ClickedJob)then
     LVHist.Items.Clear;
     CurrJob:=ClickedJob;
     Node.Selected:=true;
except
//
end;
end;

procedure TForm1.AddChangePropCase(groupnode: TTreeNode);
var
TT,TR: TTreeNode;
i,attr: Integer;
dd: DirP;
filt: dword;
TL: TListItem;
ExList: TStringList;
GG: RJob;
isexists: boolean;
begin
TR:=groupnode;
TT:=nil;
try
  if(TR = nil)then exit;
    if(TR.Parent = nil)then
    begin
      for i:=0 to TR.Count-1 do
      begin
        if(TR.Item[i].Text = CBCaseName.Text)and(TR.Item[i].ImageIndex = 5)then
        begin
        TT:=TR.Item[i];
        break;
        end;
      end;
    end
    else
    TT:=TR;
    GG:=RJob(TR.Data);
    if(TT<>nil)then
    begin
      if(TT.Data = nil)then exit;
      dd:=DirP(TT.Data);
      //GG:=dd.rj;
      ExList:=dd.PExList;
    end else
    begin
      TT:=TVG.Items.AddChild(TR,CBCaseName.Text);
      New(dd);
      dd.groupname:=TR.Text;
      TT.Data:=dd;
      ExList:=TStringList.Create;
      dd.PExList:=ExList;
      dd.listind:=GG.LItems.Add(dd);
      dd.rj:=nil;
    end;
      CurrP:=dd;
      TT.ImageIndex:=5;
      TT.SelectedIndex:=5;
      TT.Text:=CBCaseName.Text;

      dd.dname:=CBCaseName.Text;
      dd.direct:=CBDir1.ItemIndex;
      dd.report:=-2;
      dd.fparam:=CBParam1.ItemIndex;
      dd.over:=-2;
      dd.notify:=false;;
      dd.rencycle:=0;
      dd.subdirs:=CBSubDirs.Checked;
      dd.renmask:=ERenMask.Text;
      dd.maskignoredir:=CBIgnoreDir.Checked;
      dd.mask:=EMask.Text;
      dd.renameall:=CBRenAll.Checked;
      isexists:=false;
      //if exists a directory with notify
      for i:=0 to GG.LItems.Count-1 do
      if((DirP(GG.LItems.Items[i])).notify)then isexists:=true;
      GG.Save.notify:=isexists;
      CheckJobSync(GG);
      filt:=0;
      for i:=0 to 7 do
      begin
        dd.notfilt[i]:=false;
        if(LVFilters.Items.Item[i].Checked)then
        begin
        dd.notfilt[i]:=true;
        if(filt = 0)then filt:=NFilters[i]
        else
        filt:=filt or NFilters[i];
        end;
      end;
      dd.notifyfilter:=filt;
      attr:=0;
      for i:=0 to 6 do
      begin
        dd.fattrarr[i]:=false;
        if(LVAttr.Items.Item[i].Checked)then
        begin
        dd.fattrarr[i]:=true;
        attr:=attr or FileAttr[i];
        end;
      end;
      if(attr = 0)then
      begin
        dd.fattrarr[6]:=true;
        attr:=attr or FileAttr[6];
      end;
      dd.fattr:=attr;
      dd.exclusive:=CBEx.Checked;
      ExList.Clear;
      if(CBEx.Checked)then
      begin
        if(ExList<>nil)then
        for i:=0 to LVEx.Items.Count-1 do
        begin
          TL:=LVEx.Items.Item[i];
          if(TL.Checked)then
          ExList.Add(TL.Caption);
        end;
      end;
//SaveList;
except
FormLog.RecError('1003');
end;
end;

procedure TForm1.CBCaseNameKeyPress(Sender: TObject; var Key: Char);
begin
if(Key in NoFileNameSigns)then
begin
ShowMessage(mmFileNameSymbols);
Key:=#0;
end;
end;

procedure TForm1.TBMasterClick(Sender: TObject);
begin
ERenMask.Text:=InvokeRenMaster(ERenMask.Text);
end;

end.                                                       
