unit Usysscanth;

interface

uses
  Windows,SysUtils, Variants, Classes,Udefinitions;

type
  SysScanTh = class(TThread)
  private
    { Private declarations }

  protected
    procedure Execute; override;
  public
    prj: RJob;
    ad: IDRec;
    //tabortall: boolean;
    Operation: integer;
  end;

implementation

uses Uglobal;


procedure SysScanTh.Execute;
begin
try
self.FreeOnTerminate:=true;
if(not prj.complete)then exit else prj.complete:=false;
prj.ExistsJobError:=false;
prj.LTop.Clear;
prj.LFTop.Clear;
prj.appear:=0;
prj.disappear:=0;
prj.change:=0;
prj.PExecTh:=self;
CheckJobEvents(prj,true);
try
if(Operation = 0)then
begin
  if(not prj.Save.exclusive)then
  prj.ScanHistory
  else
  prj.ScanEx;
end;
if(Operation = 1)then
begin
prj.DriveExec(jmRun,0,0,Round(ad.isize/1024/1024));
prj.NowScan:=ad.parent.iname;
prj.ScanDisk(ad,ad.parent.iname);
if(prj.babort)then prj.EmptyNode(ad);
end;

if(prj.ExistsJobError)then
begin
prj.DriveExec(jmFailure);
end else
begin
prj.DriveExec(jmSuccess);
end;
if(prj.babort)then
prj.DriveExec(jmAbort);
CheckJobEvents(prj);

prj.NowScan:='';
prj.complete:=true;
finally
prj.PExecTh:=nil;
prj.LTop.Clear;
prj.LFTop.Clear;
end;
except
prj.complete:=true;
end;
end;

end.
