unit UFTPFrame;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ImgList, ComCtrls, ToolWin, ExtCtrls, StdCtrls, FtpMsg,Ftp,Udefinitions,
  Menus,StrUtils;

type
  TFTPFrame = class(TFrame)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Splitter1: TSplitter;
    TV: TTreeView;
    ToolBar1: TToolBar;
    TBConnect: TToolButton;
    TBBreak: TToolButton;
    ILFrame: TImageList;
    TBClear: TToolButton;
    TBProp: TToolButton;
    TBLogin: TToolButton;
    PopupMenu1: TPopupMenu;
    Copy1: TMenuItem;
    Cut1: TMenuItem;
    Delete1: TMenuItem;
    Paste1: TMenuItem;
    SelectAll1: TMenuItem;
    ClearAll1: TMenuItem;
    Panel4: TPanel;
    RE1: TRichEdit;
    Timer1: TTimer;
    Splitter2: TSplitter;
    TBClose: TToolButton;
    Panel5: TPanel;
    REQQ: TRichEdit;
    Panel6: TPanel;
    ToolBar2: TToolBar;
    TBClearQQ: TToolButton;
    procedure TBBreakClick(Sender: TObject);
    procedure TBConnectClick(Sender: TObject);
    procedure TBClearClick(Sender: TObject);
    procedure TBPropClick(Sender: TObject);
    procedure TBLoginClick(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure SelectAll1Click(Sender: TObject);
    procedure ClearAll1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure TBClearQQClick(Sender: TObject);
  private
    { Private declarations }
  public
    ff: FTPJob;
    scount: integer;
  end;

implementation

uses Unethood, Uglobal;

{$R *.dfm}

procedure TFTPFrame.TBBreakClick(Sender: TObject);
begin
try
ff.ttf.Abort;
except
//
end;
end;

procedure TFTPFrame.TBConnectClick(Sender: TObject);
begin
try
  if(ff.mFTP.Connected)then
  begin
    ff.ttf.Quit;
    //TBConnect.ImageIndex:=1;
  end else
  begin
    ff.ttf.Login;
    //TBConnect.ImageIndex:=0;
  end;
except
//
end;
end;

procedure TFTPFrame.TBClearClick(Sender: TObject);
begin
RE1.Clear;
scount:=0;
end;

procedure TFTPFrame.TBPropClick(Sender: TObject);
begin
try
  if(ff.mFTP.Connected)then
  begin
    ff.ttf.Quit;
    //TBConnect.ImageIndex:=1;
  end;
Application.CreateForm(TFormNetHood,FormNetHood);
FormNetHood.rj:=@ff.Save;
FormNetHood.ShowModal;
except
//
end;
end;

procedure TFTPFrame.TBLoginClick(Sender: TObject);
begin
ff.ttf.Login;
end;

procedure TFTPFrame.Cut1Click(Sender: TObject);
begin
RE1.CutToClipboard;
end;

procedure TFTPFrame.Copy1Click(Sender: TObject);
begin
RE1.CopyToClipboard;
end;

procedure TFTPFrame.Paste1Click(Sender: TObject);
begin
RE1.PasteFromClipboard;
end;

procedure TFTPFrame.Delete1Click(Sender: TObject);
begin
RE1.CutToClipboard;
end;

procedure TFTPFrame.SelectAll1Click(Sender: TObject);
begin
RE1.SelectAll;
end;

procedure TFTPFrame.ClearAll1Click(Sender: TObject);
begin
RE1.Lines.Clear;
end;

procedure TFTPFrame.Timer1Timer(Sender: TObject);
var
i,pos1,len: integer;
ccv: ComRec;
cc,vv: string;
C: TColor;
begin
try
  try
  if(ff.ttf = nil)then
  begin
  Timer1.Enabled:=false;
  exit;
  end;
  if(ff.needchecktree)then
  begin
  //ff.RescanTree;
  ff.ttf.Refresh;
  ff.needchecktree:=false;
  end;

  if(self.CanFocus)and(not ff.messlock)then
  begin
  //ff.ttf.Suspend;
   // waitres:=ff.WaitEvent(ff.hMess,100);
   // if(waitres = WAIT_OBJECT_0)then
    //begin
      //for j:=0 to ff.MessList.Count-1 do
      if(not ff.messlock)then
      while ff.MessList.Count>0 do
      begin
        cc:=ff.MessList.Strings[0];
        ff.MessList.Delete(0);
        pos1:=Pos('=',cc);
        len:=Length(cc);
        C := clBlack;
        if(cc[len] = '1')then C := clBlue else
        if(cc[len] = '2')then C := clRed else
        if(cc[len] = '3')then C := clRed else
        if(cc[len] = '4')then C := clGreen else
        if(cc[len] = '5')then C := clPurple;
        RE1.SelAttributes.Color:=C;
        Inc(scount);
        vv:=IntToStr(scount)+' : '+LeftStr(cc,pos1-1);
        RE1.Lines.Insert(0,vv);
        RE1.SelStart:=0;
        RE1.SelLength:=Length(vv);
        RE1.SelAttributes.Color:=C;
        //RE1.Lines.Add(vv+' : '+LeftStr(cc,pos1-1));
        if(RE1.Lines.Count>=999)then RE1.Lines.Delete(1000);
        if(ff.messlock)then break;
      end;
      //ff.MessList.Clear;
    //end;
    REQQ.Clear;
    i:=0;
    //waitres:=ff.WaitEvent(ff.ttf.hLock,100);
    //if(waitres = WAIT_OBJECT_0)then
    //begin
      if(not ff.ttf.thlock)then;
      while i < ff.QQ.Count do
      begin
        ccv:=ComRec(ff.QQ.Items[i]);
        Inc(i);
        C:=FTPCommColors[ccv.icomm];
        cc:=FTPCommStr[ccv.icomm];
        case ccv.icomm of
          coExpand:  cc:=cc+'  '+ccv.tr.Text;
          coExplore: cc:=cc+'  '+IDRec(ccv.prr).ilabel;
          coAbort:;
          coChangeDirectory: cc:=cc+'  '+ccv.dname;
          coChangeToParentDirectory: ;
          coCreateDirectory: cc:=cc+'  '+ccv.dname;
          coDeleteDirectory: cc:=cc+'  '+ccv.dname;
          coDeleteFile: cc:=cc+'  '+ccv.dname;
          coFileSetAttr: ;
          coGetFile: cc:=cc+'  '+ccv.dname;
          coLogin: ;
          coPutFile: cc:=cc+'  '+ccv.dname;
          coQuit: ;
          coRefresh: cc:=cc+'  '+IDRec(ff.pcrec).ilabel;
          coRenameFile: cc:=cc+'  '+ccv.dname+' to '+ccv.dnewname;
          coGetPropTo: cc:=cc+'  '+IDRec(ccv.prr).ilabel;
          coPrepareEx: cc:=cc+'  '+ccv.dname;
        end; //case cc.icomm of
        REQQ.SelAttributes.Color:=C;
        vv:=IntToStr(REQQ.Lines.Count+1);
        REQQ.Lines.Add(vv+' : '+cc);
        if(ff.ttf.thlock)then break;
      end;
    //end;
  if(ff.mFTP.Connected)then
  begin
    ff.trr.ImageIndex:=17;
    TBConnect.ImageIndex:=0;
    if(not ff.complete)then
    begin
      if(ff.trr.ImageIndex=17)then
      ff.trr.ImageIndex:=26
      else
      ff.trr.ImageIndex:=17;
    end;
  end else
  begin
    ff.trr.ImageIndex:=24;
    TBConnect.ImageIndex:=1;
  end;
  end;  //if(self.CanFocus)then
  finally
  //if(ff.ttf.Suspended)then
  //ff.ttf.Resume;
  end;
except
//
end;
end;

procedure TFTPFrame.TBCloseClick(Sender: TObject);
begin
InvokeFreeFTP(ff);
end;

procedure TFTPFrame.TBClearQQClick(Sender: TObject);
var
i: integer;
begin
try
ff.ttf.Suspend;
for i:=0 to ff.QQ.Count - 1 do
begin
ComRec(ff.QQ.Items[i]).executed:=true;
Dispose(ComRec(ff.QQ.Items[i]));
end;
ff.QQ.Clear;
finally
ff.ttf.Resume;
end;
end;

end.
