unit Uchartth;

interface

uses
  Classes,Udefinitions,ComCtrls;

type
  ChartTh = class(TThread)
  protected
    procedure Execute; override;
  public
    ad: IDRec;
    rr: RJob;
    tr: TTreeNode;
    fname: string;
    Operation: integer;
end;

implementation

uses Uchart;


procedure ChartTh.Execute;
begin
try
  if(rr<>nil)then
  begin
  rr.PExecTh:=self;
  if(not rr.complete)then exit else  rr.complete:=false;
  end;
  try
  self.FreeOnTerminate:=true;
  case Operation of
  coCreateTop     : FormChart.CreateTop(rr);
  coLoadHistory   : FormChart.LoadHistory(fname);
  coSaveHistory   : FormChart.SaveHistory(fname,rr);
  coClearSelected : FormChart.ClearSelected;
  coClearAll      : FormChart.ClearAll;
  coEmptySelected : FormChart.EmptySelected;
  coSortTop       : FormChart.SortTop(rr);
  end;
  if(rr<>nil)then
  rr.complete:=true;
  finally
  if(rr<>nil)then
  begin
  rr.PExecTh:=nil;
  rr.babort:=false;
  end;
  end;
except
if(rr<>nil)then
rr.complete:=true;
end;
end;

end.
