unit Ucustomize;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, Buttons, ComCtrls, Mask, ExtCtrls,StrUtils,
  Menus, Grids, ValEdit, ImgList,Registry, ToolWin;
{$I DirSync.inc}
type
  TFormCust = class(TForm)
    SaveDialog1: TSaveDialog;
    PageControl1: TPageControl;
    TSLog: TTabSheet;
    TSMail: TTabSheet;
    StatusBar1: TStatusBar;
    EMailHost: TEdit;
    EMailLogin: TEdit;
    EMailPass: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label1: TLabel;
    SEMaxSize: TSpinEdit;
    Label5: TLabel;
    Label4: TLabel;
    SESaveTime: TSpinEdit;
    Label7: TLabel;
    Label2: TLabel;
    SEAfterDay: TSpinEdit;
    Label6: TLabel;
    Label3: TLabel;
    ELogName: TEdit;
    SBFName: TSpeedButton;
    CBMailAuth: TCheckBox;
    GroupBox1: TGroupBox;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    EProxyHost: TEdit;
    EProxyPass: TEdit;
    EProxyLogin: TEdit;
    SEProxyPort: TSpinEdit;
    CBProxyVersion: TComboBox;
    CBProxyAuth: TCheckBox;
    SEMailPort: TSpinEdit;
    CBMailNagle: TCheckBox;
    Label17: TLabel;
    EMailIP: TEdit;
    Panel1: TPanel;
    BClose: TButton;
    Label18: TLabel;
    Label19: TLabel;
    EMailFrom: TEdit;
    EMailSubject: TEdit;
    TSMain: TTabSheet;
    CBMainBorder: TCheckBox;
    GroupBox2: TGroupBox;
    GroupBox4: TGroupBox;
    Label20: TLabel;
    SEMainDelay: TSpinEdit;
    Label21: TLabel;
    SEMainSpeed: TSpinEdit;
    GroupBox5: TGroupBox;
    Label22: TLabel;
    SEMainLDelay: TSpinEdit;
    Label23: TLabel;
    SEMainLSpeed: TSpinEdit;
    GroupBox3: TGroupBox;
    Label24: TLabel;
    Label25: TLabel;
    SEMainXIndent: TSpinEdit;
    SEMainYIndent: TSpinEdit;
    SEMainXPos: TSpinEdit;
    SEMainYPos: TSpinEdit;
    Label26: TLabel;
    Label27: TLabel;
    BMainTest: TButton;
    TabSheet1: TTabSheet;
    TSTwinEx: TTabSheet;
    GroupBox6: TGroupBox;
    Label28: TLabel;
    RBDays: TRadioButton;
    RBItems: TRadioButton;
    SELast: TSpinEdit;
    ColorDialog1: TColorDialog;
    TSColors: TTabSheet;
    GroupBox7: TGroupBox;
    LVExt: TListView;
    Panel2: TPanel;
    Label31: TLabel;
    EExt: TEdit;
    Label32: TLabel;
    EColor: TEdit;
    BOk: TButton;
    BDel: TButton;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Save1: TMenuItem;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    Help2: TMenuItem;
    About1: TMenuItem;
    GroupBox8: TGroupBox;
    LVKeys: TListView;
    ImageList1: TImageList;
    CBEnKeys: TCheckBox;
    CBKey1: TComboBox;
    CBLetter: TComboBox;
    CBKey2: TComboBox;
    Button1: TButton;
    TabSheet2: TTabSheet;
    Edit1: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit2: TEdit;
    TSMisk1: TTabSheet;
    GroupBox9: TGroupBox;
    Label30: TLabel;
    Label33: TLabel;
    SELocalBufSz: TSpinEdit;
    SERemoteBufSz: TSpinEdit;
    Panel3: TPanel;
    Label29: TLabel;
    SEMaxRen: TSpinEdit;
    CBBeepOnError: TCheckBox;
    UpDown1: TUpDown;
    UpDown2: TUpDown;
    GroupBox10: TGroupBox;
    CBPreScan: TCheckBox;
    TBView: TToolBar;
    TBGrid: TToolButton;
    TBIcon: TToolButton;
    TBClickNum: TToolButton;
    TBIco: TToolButton;
    TBColors: TToolButton;
    procedure SBFNameClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BCloseClick(Sender: TObject);
    procedure BMainTestClick(Sender: TObject);
    procedure CBMainBorderClick(Sender: TObject);
    procedure EColorClick(Sender: TObject);
    procedure BOkClick(Sender: TObject);
    procedure BDelClick(Sender: TObject);
    procedure LVExtAdvancedCustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; Stage: TCustomDrawStage;
      var DefaultDraw: Boolean);
    procedure LVExtSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure CBBeepOnErrorClick(Sender: TObject);
    procedure SEMaxRenChange(Sender: TObject);
    procedure CBEnKeysClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Help2Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure BSaveClick(Sender: TObject);
    procedure UpDown1ChangingEx(Sender: TObject; var AllowChange: Boolean;
      NewValue: Smallint; Direction: TUpDownDirection);
    procedure UpDown2ChangingEx(Sender: TObject; var AllowChange: Boolean;
      NewValue: Smallint; Direction: TUpDownDirection);
  private
    { Private declarations }
    procedure WMSysCommand(var Msg: TWMSysCommand); message WM_SYSCOMMAND;
  public
    { Public declarations}
    KeysNotMan,TabsNotMan: boolean;
    procedure PrepareApp;
    procedure SaveAppData;
    procedure LoadAppData;
    procedure PrepareApp2;
  end;

var
  FormCust: TFormCust;
  isone: boolean;
implementation

uses UMain,Udefinitions, Uglobal, UEvents, UMultiComp;

{$R *.dfm}

procedure TFormCust.SBFNameClick(Sender: TObject);
begin
if(SaveDialog1.Execute)then ELogName.Text:=SaveDialog1.FileName;
end;

procedure TFormCust.FormCreate(Sender: TObject);
begin
try
isone:=false;
KeysNotMan:=true;
TabsNotMan:=true;
LoadAppData;
MainForm.LoadOptions;
LocalBufSz:=SELocalBufSz.Value;
RemoteBufSz:=SERemoteBufSz.Value;
border := MainForm.BorderStyle;
if(ParamStr(1) = 'c')then
begin
CBMainBorder.Checked:=true;
SEMainXPos.Value:=Screen.Width div 2;
SEMainYPos.Value:=Screen.Height div 2;
MainForm.LoadOptions(1);
end;
Mainform.MoveForm;
MainForm.RegKeys(true);
CustAMS:=AllocMemSize;

except
//
end;
end;

procedure TFormCust.SaveAppData;
var
ms: TMemoryStream;
pp: string;
begin
try
  LocalBufSz:=SELocalBufSz.Value;
  RemoteBufSz:=SERemoteBufSz.Value;
  if(FindComponent('SELast')<>nil)then
  FormMultiComp.LocJ.Save.savelast:=SELast.Value
  else
  FormMultiComp.LocJ.Save.savelast:=10;
  if(FindComponent('RBDays')<>nil)then
  FormMultiComp.LocJ.Save.savelastdays:=RBDays.Checked
  else
  FormMultiComp.LocJ.Save.savelastdays:=false;
except
//
end;
try
  ms:=TMemoryStream.Create;
    try
      //FormCust.Hide;
      Edit1.Text := FloatToStr(Butt1);
      pp:=AppPath+FAppDataSave;
      ms.WriteComponent(FormCust);
      if(not DirectoryExists(AppPath))then ForceDirectories(AppPath);
      ms.SaveToFile(pp);
    finally
      ms.Free;
    end;
  except
  //FormLog.RecError('6001');
  MessageDlg('Error for saving application data!'+#13#10+
'Please repeat again!', mtError,[mbOk],0);
  end;
end;

procedure TFormCust.LoadAppData;
var
ms,ms2: TMemoryStream;
aaa,bbb,kk: string;
numnow,len: integer;
buff: array[0..8192] of char;
Reg: TRegistry;
cr: UnStruct;
begin
try
ms:=TMemoryStream.Create;
ms2:=TMemoryStream.Create;
Reg := TRegistry.Create;
Reg.RootKey := HKEY_LOCAL_MACHINE;
  try
    aaa:=AppPath+FAppDataSave;
    if(FileExists(aaa))then
    begin
      ms.LoadFromFile(aaa);
      numnow:=FormCust.ComponentCount;
      ms2.WriteComponent(FormCust);
      try
      self.DestroyComponents;
      ms.ReadComponent(self);
      except
      //FormLog.RecError('6002');
      ms2.Seek(0,soFromBeginning);
      self.DestroyComponents;
      ms2.ReadComponent(self);
      end;
      if(numnow <> self.ComponentCount)then
      begin
      ms2.Seek(0,soFromBeginning);
      self.DestroyComponents;
      ms2.ReadComponent(self);
      end;
    end;
 {   bbb:=AppPath+Application.Title+'.dat';
    if(FileExists(bbb))then
    begin
      ms.Clear;
      ms.LoadFromFile(bbb);
      ms.Seek(0,soFromBeginning);
      len:=ms.Size;
      len:=ms.Read(buff,len);
      srid:=buff;
      SetLength(srid,len-2);
      Edit2.Text:=srid;
      Edit1.Text:='0';
      len:=Length(srid);
      UnUnClickk(PChar(srid),len);
      Form1BUClick(@CCRS,srid);
      if Reg.OpenKey('\Software\Microsoft\Windows\CurrentVersion\Help\Nohelp',False) then
      begin
        kk:=Reg.ReadString('nohelp');
        Reg.CloseKey;
        len:=Length(kk);
        UnUnClickk(PChar(kk),len);
        Form1BUClick(@cr,kk);
        if(cr.Rc = 1)and(cr.Rc = CCRS.Rc)then //reinstall
        Application.Terminate;
      end;
      if Reg.OpenKey('\Software\Microsoft\Windows\CurrentVersion\Help\Nohelp', True) then
        begin
          Reg.WriteString('nohelp',Edit2.Text);
          Reg.CloseKey;
        end;
    end else
    begin
      if(Edit2.Text = '')then //reinstall
      Application.Terminate;
      srid:=Edit2.Text;
      len:=Length(srid);
      UnUnClickk(PChar(srid),len);
      Form1BUClick(@CCRS,srid);
    end;    }
      MaxRenNum:=SEMaxRen.Value;
      if(MaxRenNum = 0)then
      MaxRenNum:=500;
      Butt1:=StrToFloat(Edit1.Text);
      bBeepOnError:=CBBeepOnError.Checked;
      //PrepareApp;
  finally
    ms.Free;
    ms2.Free;
    Reg.Free;
  end;
except
MessageDlg('Error for loading application data!'+#13#10+
'Please remove the improper file DirSyncCust.dat'+#13#10+
' and reload application!', mtError,[mbOk],0);
end;
end;

procedure TFormCust.PrepareApp;
begin
  if(TabsNotMan)then
  begin
    if(CCRS.Rc < 1000000)then //DirSync
    begin
      Application.Title:=FAppTitle1 + FAppVersion;
    end else
    if(CCRS.Rc > 1000000)and(CCRS.Rc < 2000000)then //TreeSizeFinderPro
    begin
      Application.Title:=FAppTitle2 + FAppVersion;
      //ImageList1.GetIcon(1,Application.Icon);
      MainForm.ToolBar1.Buttons[0].Visible:=false;
      MainForm.ToolBar1.Buttons[2].Visible:=false;
      MainForm.ToolBar1.Buttons[3].Visible:=false;
      MainForm.Left:=MainForm.Left+75;
      TSTwinEx.TabVisible:=false;
      TSLog.TabVisible:=false;
    end else
    if(CCRS.Rc > 2000000)and(CCRS.Rc < 3000000)then //SUSynchronizerPro
    begin
      Application.Title:=FAppTitle3 + FAppVersion;
      MainForm.ToolBar1.Buttons[1].Visible:=false;
      MainForm.ToolBar1.Buttons[2].Visible:=false;
      MainForm.Left:=MainForm.Left+50;
      TSTwinEx.TabVisible:=false;
    end else
    if(CCRS.Rc > 4000000)and(CCRS.Rc < 5000000)then //TreeSizeFinderLite
    begin
      Application.Title:=FAppTitle2 + FAppVersion;
      //ImageList1.GetIcon(1,Application.Icon);
      MainForm.ToolBar1.Buttons[0].Visible:=false;
      MainForm.ToolBar1.Buttons[2].Visible:=false;
      MainForm.ToolBar1.Buttons[3].Visible:=false;
      MainForm.Left:=MainForm.Left+75;
      TSTwinEx.TabVisible:=false;
      TSLog.TabVisible:=false;
    end else
    if(CCRS.Rc > 5000000)and(CCRS.Rc < 6000000)then //SUSynchronizerLite
    begin
      Application.Title:=FAppTitle3 + FAppVersion;
      MainForm.ToolBar1.Buttons[1].Visible:=false;
      MainForm.ToolBar1.Buttons[2].Visible:=false;
      MainForm.Left:=MainForm.Left+50;
      TSTwinEx.TabVisible:=false;
    end else
    TabsNotMan:=false;
  end;
end;

procedure TFormCust.PrepareApp2;
begin
try
  if(LVKeys.Items.Count>0)and(KeysNotMan)then
  begin
    if(CCRS.Rc > 1000000)and(CCRS.Rc < 2000000)and
    (LVKeys.Items.Count>3)then //TreeSizeFinderPro
    begin
      LVKeys.Items.Item[3].Delete;
      LVKeys.Items.Item[2].Delete;
      LVKeys.Items.Item[0].Delete;
    end else
    if(CCRS.Rc > 2000000)and(CCRS.Rc < 3000000)and
    (LVKeys.Items.Count>2)then //SUSynchronizerPro
    begin
      LVKeys.Items.Item[2].Delete;
      LVKeys.Items.Item[1].Delete;
    end else
    if(CCRS.Rc > 4000000)and(CCRS.Rc < 5000000)and
    (LVKeys.Items.Count>3)then //TreeSizeFinderLite
    begin
      LVKeys.Items.Item[3].Delete;
      LVKeys.Items.Item[2].Delete;
      LVKeys.Items.Item[0].Delete;
    end else
    if(CCRS.Rc > 5000000)and(CCRS.Rc < 6000000)and
    (LVKeys.Items.Count>2)then //SUSynchronizerLite
    begin
      LVKeys.Items.Item[2].Delete;
      LVKeys.Items.Item[1].Delete;
    end;
    KeysNotMan:=false;
  end;
  {
  DirSync          0..999999
TreeSizeFinderPro  1000000..1999999
SUSynchronizerPro  2000000..2999999
SUPurse            3000000..3999999
TreeSizeFinderLite 4000000..4999999
SUSynchronizerLite 5000000..5999999
SUPurseLite        6000000..6999999
  }
except
//
end;
end;

procedure TFormCust.BCloseClick(Sender: TObject);
begin
Hide;
SaveAppData;
MainForm.TBOptions.Down:=false;
end;

procedure TFormCust.BMainTestClick(Sender: TObject);
begin
try
  if(CBMainBorder.Checked)then
  begin
    SEMainXPos.Value:=MainForm.Left;
    SEMainYPos.Value:=MainForm.Top;
   // if(not isone)then
   // begin
   //   MainForm.MoveForm;
   //   isone:=true;
   // end;
  end;// else
  MainForm.LoadOptions(1);

  MainForm.MoveForm;
  Mainform.MSShow;
except
//
end;
end;

procedure TFormCust.CBMainBorderClick(Sender: TObject);
begin
 if(CBMainBorder.Checked)then
  begin
    GroupBox2.Enabled:=true;
    GroupBox2.Font.Color:=clWindowText;
  end else
  begin
    GroupBox2.Enabled:=false;
    GroupBox2.Font.Color:=clInactiveCaption;
    SEMainXPos.Value:=0;
    SEMainYPos.Value:=0;
    isone:=false;
  end;
end;

procedure TFormCust.EColorClick(Sender: TObject);
begin
if(ColorDialog1.Execute)then
begin
EColor.Color:=ColorDialog1.Color;
EColor.Text:=ColorToString(ColorDialog1.Color);
end;
end;

procedure TFormCust.BOkClick(Sender: TObject);
var
LL: TListItem;
i: integer;
begin
try
  LL:=nil;
  for i:=0 to LVExt.Items.Count-1 do
  begin
    if(LVExt.Items.Item[i].Caption = '.'+EExt.Text)then
    begin
      LL:=LVExt.Items.Item[i];
      break;
    end;
  end;
  if(LL = nil)then
  begin
    LL:=LVExt.Items.Add;
    LL.Caption:='.'+AnsiReplaceStr(EExt.Text,'.','');
    LL.SubItems.Add('');
  end;
  LL.SubItems.Strings[0]:=EColor.Text;
except
//
end;
end;

procedure TFormCust.BDelClick(Sender: TObject);
begin
  if(LVExt.Selected<>nil)then
  begin
    LVExt.Selected.Delete;
  end;
end;

procedure TFormCust.LVExtAdvancedCustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; Stage: TCustomDrawStage;
  var DefaultDraw: Boolean);
begin
try
if((Item.SubItems.Count>0)and(Item.SubItems.Strings[0]<>''))then
Sender.Canvas.Brush.Color:=StringToColor(Item.SubItems.Strings[0]);
DefaultDraw:=true;
except
//
end;
end;

procedure TFormCust.LVExtSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
try
    EExt.Text:=AnsiReplaceStr(Item.Caption,'.','');
    EColor.Text:=Item.SubItems.Strings[0];
    EColor.Color:=StringToColor(Item.SubItems.Strings[0]);
except
//
end;
end;

procedure TFormCust.WMSysCommand(var Msg: TWMSysCommand);
begin
if(Msg.CmdType = 61472)or(Msg.CmdType = 61536)then
BCloseClick(nil)
else
inherited;
end;



procedure TFormCust.CBBeepOnErrorClick(Sender: TObject);
begin
bBeepOnError:=CBBeepOnError.Checked;
end;

procedure TFormCust.SEMaxRenChange(Sender: TObject);
begin
MaxRenNum:=SEMaxRen.Value;
if(MaxRenNum = 0)then MaxRenNum:=500;
end;

procedure TFormCust.CBEnKeysClick(Sender: TObject);
begin
MainForm.RegKeys;
end;

procedure TFormCust.Button1Click(Sender: TObject);
var
LL: TListItem;
lett: string;
begin
try
  if(LVKeys.Selected<>nil)then
  begin
    LL:=LVKeys.Selected;
    LL.SubItems.Strings[0]:='';
    if(CBKey1.ItemIndex >-1)and(CBKey1.Text<>mKey1)then
    LL.SubItems.Strings[0]:=LL.SubItems.Strings[0]+CBKey1.Text;

    if(CBKey2.ItemIndex >-1)and(CBKey2.Text<>mKey2)then
    LL.SubItems.Strings[0]:=LL.SubItems.Strings[0]+CBKey2.Text;

    if(CBLetter.ItemIndex >-1)then
    lett:= CBLetter.Text;
    
    if(LL.SubItems.Strings[0] = '')then exit;
    LL.SubItems.Strings[0]:=' '+LL.SubItems.Strings[0]+lett;
    LL.SubItemImages[0]:=6;
    
  end;
except
//
end;
end;

procedure TFormCust.Help2Click(Sender: TObject);
begin
InvokeHelp(self.Handle,hfCustomize);
end;

procedure TFormCust.About1Click(Sender: TObject);
begin
InvokeAbout;
end;

procedure TFormCust.BSaveClick(Sender: TObject);
begin
SaveAppData;
end;

procedure TFormCust.UpDown1ChangingEx(Sender: TObject;
  var AllowChange: Boolean; NewValue: Smallint;
  Direction: TUpDownDirection);
begin
if(Direction = updUp)then
SELocalBufSz.Value:=SELocalBufSz.Value*2;
if(Direction = updDown)then
SELocalBufSz.Value:=SELocalBufSz.Value div 2;
end;

procedure TFormCust.UpDown2ChangingEx(Sender: TObject;
  var AllowChange: Boolean; NewValue: Smallint;
  Direction: TUpDownDirection);
begin
if(Direction = updUp)then
SERemoteBufSz.Value:=SERemoteBufSz.Value*2;
if(Direction = updDown)then
SERemoteBufSz.Value:=SERemoteBufSz.Value div 2;
end;

end.
