unit Ugrsync;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls,Math, ExtCtrls, ImgList, StdCtrls, Buttons, ToolWin,
  StrUtils,Masks,SyncObjs,Udefinitions, Menus,DateUtils, Gauges, AppEvnts;

type
  TFormGrSync = class(TForm)
    IMG: TImageList;
    Panel2: TPanel;
    SB: TStatusBar;
    Panel4: TPanel;
    Panel3: TPanel;
    LVDirs: TListView;
    Splitter1: TSplitter;
    Label1: TLabel;
    LTo: TLabel;
    CBErrStop: TCheckBox;
    CBClose: TCheckBox;
    MainMenu1: TMainMenu;
    Help1: TMenuItem;
    StoponError1: TMenuItem;
    CloseifnoError1: TMenuItem;
    NonvisualSync1: TMenuItem;
    Help2: TMenuItem;
    File1: TMenuItem;
    Start1: TMenuItem;
    Suspend1: TMenuItem;
    Help3: TMenuItem;
    About1: TMenuItem;
    Timer2: TTimer;
    ToolBar1: TToolBar;
    TBFirst: TToolButton;
    TBBack: TToolButton;
    TBPrevI: TToolButton;
    TBNextI: TToolButton;
    TBNext: TToolButton;
    TBLast: TToolButton;
    Timer1: TTimer;
    Label3: TLabel;
    LElapsed: TLabel;
    Exit1: TMenuItem;
    Gauge1: TGauge;
    Gauge2: TGauge;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    LNow: TLabel;
    ToolBar3: TToolBar;
    TBAuto: TToolButton;
    TBInvert: TToolButton;
    TBShowAllF: TToolButton;
    TBShowFilter: TToolButton;
    TBDefault: TToolButton;
    ToolButton2: TToolButton;
    TBExit: TToolButton;
    ToolBar6: TToolBar;
    TBShowM: TToolButton;
    TBRecycle: TToolButton;
    TBDel: TToolButton;
    TBCopy: TToolButton;
    TBMove: TToolButton;
    TBRen: TToolButton;
    TBMRecycle: TToolButton;
    TBEmpty: TToolButton;
    TBMoveContent: TToolButton;
    TBSort: TToolButton;
    TBColors: TToolButton;
    TBStart: TToolButton;
    ToolButton1: TToolButton;
    ToolButton3: TToolButton;
    PopupTop: TPopupMenu;
    Show1: TMenuItem;
    MoveToRecycle1: TMenuItem;
    Delete2: TMenuItem;
    Copy1: TMenuItem;
    Move1: TMenuItem;
    Rename1: TMenuItem;
    Empty1: TMenuItem;
    EmptyToRecycle1: TMenuItem;
    MoveContent1: TMenuItem;
    TBCollapse: TToolButton;
    Label13: TLabel;
    LItems: TLabel;
    TBIco: TToolButton;
    TBAbort: TToolButton;
    TBAssign: TToolButton;
    TBSuccess: TToolButton;
    TBFailure: TToolButton;
    TBFAbort: TToolButton;
    CBERetry: TComboBoxEx;
    PCurrProp: TPanel;
    PCurrent: TPanel;
    Panel7: TPanel;
    LVDSync: TListView;
    PProp: TPanel;
    LVAttr: TListView;
    ESize: TEdit;
    ETCreate: TEdit;
    ETAccess: TEdit;
    ETWrite: TEdit;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    LNum: TLabel;
    BApply: TButton;
    TBProp1: TToolButton;
    Panel1: TPanel;
    ToolBar2: TToolBar;
    TBSkip: TToolButton;
    TBExPrev: TToolButton;
    TBExNext: TToolButton;
    ImgListTop: TImageList;
    ApplicationEvents1: TApplicationEvents;
    TBHidePan: TToolButton;
    MCurr: TRichEdit;
    Splitter2: TSplitter;
    procedure FormCreate(Sender: TObject);
    procedure StoponError1Click(Sender: TObject);
    procedure CloseifnoError1Click(Sender: TObject);
    procedure CBErrStopKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CBCloseKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Timer2Timer(Sender: TObject);
    procedure TBExitClick(Sender: TObject);
    procedure TBStartClick(Sender: TObject);
    procedure TBDefaultClick(Sender: TObject);
    procedure TBFirstClick(Sender: TObject);
    procedure SBDrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel;
      const Rect: TRect);
    procedure TBShowAllFClick(Sender: TObject);
    procedure TBInvertClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure LVDSyncColumnClick(Sender: TObject; Column: TListColumn);
    procedure TBSortClick(Sender: TObject);
    procedure LVDSyncAdvancedCustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; Stage: TCustomDrawStage;
      var DefaultDraw: Boolean);
    procedure TBShowFilterClick(Sender: TObject);
    procedure TBColorsClick(Sender: TObject);
    procedure TBShowMClick(Sender: TObject);
    procedure PopupTopPopup(Sender: TObject);
    procedure Show1Click(Sender: TObject);
    procedure LVDSyncClick(Sender: TObject);
    procedure TBCollapseClick(Sender: TObject);
    procedure TBAbortClick(Sender: TObject);
    procedure LVDSyncMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure LVDSyncSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure TBIcoClick(Sender: TObject);
    procedure TBSkipClick(Sender: TObject);
    procedure CBErrStopClick(Sender: TObject);
    procedure CBERetryChange(Sender: TObject);
    procedure CBCloseClick(Sender: TObject);
    procedure TBProp1Click(Sender: TObject);
    procedure LVAttrChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure BApplyClick(Sender: TObject);
    procedure ETCreateKeyPress(Sender: TObject; var Key: Char);
    procedure ETAccessKeyPress(Sender: TObject; var Key: Char);
    procedure ETWriteKeyPress(Sender: TObject; var Key: Char);
    procedure ETWriteChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Help3Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure TBExPrevClick(Sender: TObject);
    procedure TBExNextClick(Sender: TObject);
    procedure ApplicationEvents1Message(var Msg: tagMSG;
      var Handled: Boolean);
    procedure TBHidePanClick(Sender: TObject);
  private
    { Private declarations }
    selfindex: integer;
  public
    { Public declarations }
    needclear: boolean;
    iFrom,iTo: integer;
    TempJ: RJob;
    CurrItem: CompData;
    RTCreate,RTAccess,RTWrite: string;
    GGG: GrSyncThP;
    ASTH: SyncATh;
    wrongchar: boolean;
    ind,phigh: integer;
    groupname,ms: string;
    tstart,tvalue,tval2: TDateTime;
    showstop,sortstop,LastStr: boolean;
    Lpp: TPoint;
    ico: TIcon;
    procedure ClearLists;
    procedure ShowDisks;
    procedure ColumnSort;
    procedure ListMenuClick(LVDSync: TListView;imgindex: integer);
    procedure CalcSpace(CV: CompData;newindex: integer;dd: IDRec;LD: TDList=nil);
    procedure CollapseChild(CV: CompData;iscollapse: boolean = false);
    procedure ShowRecTh(showmode: integer;flag: integer=1);
    procedure SetTh(GGG1: Pointer);
    procedure SetTh2(GGG1: Pointer);
    function  FindRootDir(ddir: string): TDList;
    function  AssignColumns(ColInd: integer): integer;
    procedure FilterSync;
    procedure Escape;
  end;
  procedure ShowSyncRecords(tto: integer;num: integer = -1);
  procedure HideForm;
var
  FormGrSync: TFormGrSync;

implementation

uses UMain, ULog, Umansync, Uglobal, UReqDialog, UDirDialog,
  UFormRen;

{$R *.dfm}

procedure TFormGrSync.SetTh(GGG1: Pointer);
begin
GGG:=GrSyncThP(GGG1);
end;

procedure TFormGrSync.SetTh2(GGG1: Pointer);
begin
ASTH:=SyncATh(GGG1);
end;

procedure HideForm;
begin
FormGrSync.Hide;
end;

procedure TFormGrSync.FormCreate(Sender: TObject);
begin
try
sortstop:=false;
LastStr:=true;
self.FreeOnRelease;
TempJ:=nil;
selfindex:= GrSyncFormList.Add(self);
CurrItem:=nil;
self.FreeOnRelease;
ico:= TIcon.Create;
needclear:=false;
iFrom:=0;
iTo:=0;
CBERetry.ItemIndex:=0;
tstart:=Now;
ASTH := nil;
showstop:=false;
tvalue:=0;
tval2:=0;
PCurrent.Height:=0;
PProp.Height:=0;
except
//
end;
end;

{
DispatchList - here we are sorting items and deleting dublicates
}

procedure TFormGrSync.ShowDisks;
var
tt: TListItem;
dd,df: TDList;
i,j: integer;
sum: real;
pdisk: string;
begin
  try
    sum:=0;
    LVDirs.Items.Clear;
    pdisk:='';
    for i:=0 to Tempj.LItems.Count-1 do
    begin
      dd:=TDList(Tempj.LItems.Items[i]);
      if(dd.DPar.rj = nil)then
      continue;
      dd.DPar.Disk.abort:=0;
      dd.DPar.Disk.err:=0;
      dd.DPar.Disk.down:=0;
      //if(dd.DPar.itype = dtShow)then continue;
      //Label14.Caption:=Label14.Caption+IntToStr(dd.ifiles)+' - '+IntToStr(dd.ifolders);
      tt:=LVDirs.Items.Add;
      tt.Caption:=dd.DPar.dname;
      tt.SubItems.Add('');
      tt.SubItems.Add('');
      tt.SubItems.Add('');
      tt.SubItems.Add('');
      tt.SubItems.Add('');
      tt.SubItems.Add('');
      tt.SubItems.Add('');
      tt.SubItems.Add('');
      tt.SubItems.Strings[0]:=dd.DPar.Disk.disk;
      tt.SubItems.Strings[2]:=IntToStr(dd.DPar.Disk.items);
      tt.SubItems.Strings[3]:=IntToStr(dd.DPar.Disk.down);
      tt.SubItems.Strings[4]:=IntToStr(dd.DPar.Disk.err);
      tt.SubItems.Strings[5]:=IntToStr(dd.DPar.Disk.abort);
      tt.SubItems.Strings[6]:=SizeString(dd.DPar.Disk.required);
      tt.Data:=dd;
      dd.DL:=tt;
      if(dd.DPar.itype = dtDir)then
      begin //1
        if(dd.DPar.rj.Save.jobtype = jtRemoteFTP)then
        begin
          dd.DPar.Disk.disk:=ExtractFileDrive(dd.DPar.dname);
          dd.DPar.Disk.free:=0;
        end else
        if(dd.DPar.rj.Save.jobtype = jtLocal)then
        begin
          dd.DPar.Disk.disk:=ExtractFileDrive(dd.DPar.dname);
          dd.DPar.Disk.free:=DriveFree(ExtractFileDrive(dd.DPar.dname));
        end;
      tt.SubItems.Strings[0]:=dd.DPar.Disk.disk;
      tt.SubItems.Strings[1]:=SizeString(dd.DPar.Disk.free);

      if(pdisk<>dd.DPar.Disk.disk)then
      begin
        sum:=0;
        for j:=0 to Tempj.LItems.Count-1 do
        begin
          df:=TDList(Tempj.LItems.Items[j]);
          if(df.DPar.Disk.disk = dd.DPar.Disk.disk)then
          begin
            sum:=sum + df.DPar.Disk.required;
          end;
        end;
      end;
      tt.ImageIndex:=12;
      if(sum >= (dd.DPar.Disk.free - dd.DPar.Disk.free/10))and(dd.DPar.rj.Save.jobtype <> jtRemoteFTP)then
      begin
        tt.SubItems.Strings[7]:=mmWarning;
        tt.ImageIndex:=11;
      end else
      begin
        tt.SubItems.Strings[7]:=mmOK;
      end;
      pdisk:=dd.DPar.Disk.disk;
      end else //1
      begin
        case dd.DPar.itype of
        dtRecycle: tt.ImageIndex := aiMoveToRecycle;
        dtDelete : tt.ImageIndex := aiDelete;
        dtShow   : tt.ImageIndex := aiShow;
        dtRename : tt.ImageIndex := aiRenameTo;
      end;

      end;
    end;
  except
  FormLog.RecError('2001');
  end;
end;

procedure TFormGrSync.ClearLists;
var
i: integer;
begin
try
for i:=0 to Tempj.LTop.Count-1 do
begin
Finalize(CompData(Tempj.LTop.Items[i])^);
Dispose(CompData(Tempj.LTop.Items[i]));
end;

for i:=0 to Tempj.LItems.Count-1 do
TDList(Tempj.LItems.Items[i]).Free;

Tempj.LFTop.Clear;
except
//
end;
end;

procedure TFormGrSync.StoponError1Click(Sender: TObject);
begin
CBErrStop.Checked:=not CBErrStop.Checked;
end;

procedure TFormGrSync.CloseifnoError1Click(Sender: TObject);
begin
CBClose.Checked:=not CBClose.Checked;
end;

procedure TFormGrSync.CBErrStopKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if(Key = 13)then CBErrStop.Checked:=not CBErrStop.Checked;
end;

procedure TFormGrSync.CBCloseKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if(Key = 13)then CBClose.Checked:=not CBClose.Checked;
end;

procedure TFormGrSync.Timer2Timer(Sender: TObject);
var
dd: TDList;
i: integer;
ss: string;
begin
if(bShutDownAll)then
begin
Timer2.Enabled:=false;
exit;
end;
if(TempJ = nil)then exit;
try
  if(TBProp1.Down)and(LVDSync.Items.Count>0)and(LVDSync.Selected = nil)then
  begin
  LVDSync.Items.Item[0].Selected:=true;
  end;
  if(TempJ.babort)then
  begin
    Timer2.Enabled:=false;
    exit;
  end;
  SB.Panels.Items[1].Text:='  Total: '+IntToStr(TempJ.LTop.Count);
 { if(SB.Font.Color = clBlack)then
  SB.Font.Color:=clRed
  else
  SB.Font.Color:=clBlack;  }
  LNow.Caption:=DateTimeToStr(Now);
    if(TempJ.StageStr <> '')then
    begin
      if(LastDelimiter(#13#10,TempJ.StageStr)>0)then
      TempJ.StageStr:=MidStr(TempJ.StageStr,0,Length(TempJ.StageStr)-2);
      if(not TempJ.syncended)then
      begin
        //if(LastStr)then
        MCurr.Lines.Insert(0,TempJ.StageStr);
       // else
       // begin
       // MCurr.Lines.Delete(0);
       // MCurr.Lines.Strings[0]:=ss;
       // end;
      LastStr:=true;
      end else
      ms:=TempJ.StageStr;
      TempJ.StageStr:='';
    end else
    begin
      if(TempJ.MessStr1<>'')then
      begin
        ss:=TempJ.MessStr1;
        if(LastStr)then
        MCurr.Lines.Insert(0,ss)
        else
        MCurr.Lines.Strings[1]:=ss;
        MCurr.SelStart:=0;
        MCurr.SelLength:=Length(ss);
        MCurr.SelAttributes.Color:=clGreen;
        TempJ.MessStr1:='';
        MCurr.SelStart:=0;
      end;
      if(TempJ.MessStr<>'')then
      begin
        ss:=TempJ.MessStr;
        if(LastStr)then
        MCurr.Lines.Insert(0,ss)
        else
        MCurr.Lines.Strings[0]:=ss;
        MCurr.SelStart:=0;
        MCurr.SelLength:=Length(ss);
        MCurr.SelAttributes.Color:=clBlue;
        TempJ.MessStr:='';
        MCurr.SelStart:=0;
      end;
      LastStr:=false;
      if(ms <> '')then
      begin
        MCurr.Lines.Insert(0,ms);
        ms:='';
        //LastStr:=true;
      end;
    end;
  if(GGG<>nil)and(GGG.Suspended)then
  if(TBStart.ImageIndex = 39)then TBStart.ImageIndex:=49 else TBStart.ImageIndex:=39
  else
  TBStart.ImageIndex:=39;
  if(ASTH<>nil)then
  begin
    TBAbort.Enabled:=true;
    if(TBAbort.ImageIndex = 26)then
    TBAbort.ImageIndex := 42
    else
    TBAbort.ImageIndex := 26;
  end else
  begin
  TBAbort.ImageIndex := 26;
  TBAbort.Enabled:=false;
  end;
  for i:=0 to Tempj.LItems.Count-1 do
  begin
    dd:=TDList(Tempj.LItems.Items[i]);
    if(dd = nil)or(dd.DL = nil)or(not dd.DPar.Disk.changed)then continue;
    dd.DL.SubItems.Strings[2]:=IntToStr(dd.DPar.Disk.items);
    dd.DL.SubItems.Strings[3]:=IntToStr(dd.DPar.Disk.down);
    dd.DL.SubItems.Strings[4]:=IntToStr(dd.DPar.Disk.err);
    dd.DL.SubItems.Strings[5]:=IntToStr(dd.DPar.Disk.abort);
    dd.DL.SubItems.Strings[6]:=SizeString(dd.DPar.Disk.required);
    dd.DPar.Disk.changed:=false;
  end;
except
FormLog.RecError('0003'+ mmFatalError);
Timer2.Enabled:=false;
end;
end;

procedure TFormGrSync.TBExitClick(Sender: TObject);
begin
Escape;
end;

procedure TFormGrSync.TBAbortClick(Sender: TObject);
begin
try
  showstop:=true;
  if(ASTH<>nil)then ASTH.Terminate;
  ASTH:=nil;
  TBShowAllF.Down:=false;
except
//
end;
end;

procedure TFormGrSync.TBStartClick(Sender: TObject);
begin
try
  if(GGG<>nil)then
  begin
    if(not GGG.Suspended)then
    begin
      GGG.Suspend;
      TempJ.StageStr:='<--->'+mmExecSuspended+#13#10+TempJ.StageStr;
    end else
    begin
      GGG.Resume;
      TempJ.StageStr:='<--->'+mmExecGoOn+#13#10+TempJ.StageStr;
    end;
  end;
except
//
end;
end;

procedure ShowSyncRecords(tto: integer;num: integer = -1);
var
i,sss,ddd,j,pos: integer;
CV,cc: CompData;
TL: TListItem;
ff: TFormGrSync;
begin
ff:=FormGrSync;
try
sss:=ff.LVDSync.VisibleRowCount;
ff.TempJ.LFView.Clear;
  for i:=0 to ff.TempJ.LTop.Count-1 do
  begin
    CV:=CompData(ff.TempJ.LTop.Items[i]);
    if(num > -1)then
    CV.expanded:=true
    else
    if(CV.parent<>nil)and(not CV.parent.expanded)then
    continue;
    ff.TempJ.LFView.Add(CV);
  end;
  for i:=0 to sss-ff.LVDSync.Items.Count-1 do
  begin
  TL:=ff.LVDSync.Items.Add;
  TL.ImageIndex:=-1;
  TL.StateIndex:=-1;
  TL.SubItems.Add('');
  TL.SubItems.Add('');
  TL.SubItems.Add('');
  TL.SubItems.Add('');
  TL.SubItems.Add('');
  TL.SubItems.Add('');
  end;
if(not ff.TempJ.defaultfilter)then
begin
ddd:=ff.TempJ.LFTop.Count;
end else
ddd:=ff.TempJ.LFView.Count;

case tto of
  slcFirst:
  begin
    ff.iFrom:=0;
    if(sss<=ddd)then ff.iTo:=sss else ff.iTo:=ddd;
  end;
  slcBBack:
  begin
    if(ff.iFrom-sss>0)then ff.iFrom:=ff.iFrom - sss else ff.iFrom:=0;
    if(ff.iFrom+sss<ddd)then ff.iTo:=ff.iFrom+sss else ff.iTo:=ddd;
  end;
  slcBack:
  begin
    if(ff.iFrom-1>0)then ff.iFrom:=ff.iFrom - 1 else ff.iFrom:=0;
    if(ff.iFrom+sss<ddd)then ff.iTo:=ff.iFrom+sss else ff.iTo:=ddd;
  end;
  slcNext:
  begin
    if(ff.iTo+1<=ddd)then ff.iTo:=ff.iTo+1 else ff.iTo:=ddd;
    if(ff.iTo-sss>0)then ff.iFrom:=ff.iTo-sss else ff.iFrom:=0;
  end;
  slcNNext:
  begin
    if(ff.iTo+sss<=ddd)then ff.iTo:=ff.iTo+sss else ff.iTo:=ddd;
    if(ff.iTo-sss<0)then ff.iFrom:=0 else ff.iFrom:=ff.iTo - sss;
  end;
  slcLast:
  begin
    if(sss<=ddd)then ff.iFrom:=ddd-sss else ff.iFrom:=0;
    ff.iTo:=ddd;
  end;
  slcAll:
  begin
    ff.iFrom:=0;
    ff.iTo:=ff.TempJ.LFTop.Count-1;
  end;
  slcFiltered:
  begin
    ff.iFrom:=0;
    ff.iTo:=ddd;
  end;
  slcCurrent:
  begin
    if(num>=0)then ff.iFrom:=num else ff.iFrom:=0;
    if(ff.iFrom+sss<=ddd)then ff.iTo:=ff.iFrom+sss else ff.iTo:=ddd;
  end;
end;
  i:=ff.iFrom;
  while(i<ff.iTo)and(i<ddd)do
  begin
    if(ff.TempJ.babort)then exit;
    if(ff.showstop)then
    begin
    ff.showstop:=false;
    exit;
    end;
    if(not ff.TempJ.defaultfilter)then
    CV:=CompData(ff.TempJ.LFTop.Items[i])
    else
    CV:=CompData(ff.TempJ.LFView.Items[i]);

    pos:=i-ff.iFrom;
    if(pos<ff.LVDSync.Items.Count)then
    begin
      TL:=ff.LVDSync.Items.Item[pos];
      if(TL.Data<>nil)then
      begin
        cc:=CompData(TL.Data);
        cc.cdItem:=nil;
        CV.cdItem:=TL;
      end else
      CV.cdItem:=TL;
    end else
    begin
      TL:=ff.LVDSync.Items.Add;
      TL.SubItems.Add('');
      TL.SubItems.Add('');
      TL.SubItems.Add('');
      TL.SubItems.Add('');
      TL.SubItems.Add('');
      TL.SubItems.Add('');
      CV.cdItem:=TL;
    end;
      TL.ImageIndex:=-1;
      TL.StateIndex:=-1;
      TL.SubItemImages[0]:=-1;
      TL.SubItemImages[1]:=-1;
      TL.SubItemImages[2]:=-1;

    if((ff.TempJ.defaultfilter)and(CV.parent <> nil))or((CV.ilevel = 0)or
    (CV.dirfrom.fparam = fpEmpty)or(CV.dirfrom.fparam = fpSmartSlave))then
    begin //3
      if(CV.cdItem = nil)then continue;
      CV.cdItem.Caption:=ExtractFileName(CV.idd.iname);
      if(CV.cdItem.Caption = '')then CV.cdItem.Caption:=CV.idd.iname;
      CV.cdItem.Indent:=CV.ilevel;
      if(CV.achild<>nil)then
      begin
        if(not CV.expanded)then CV.cdItem.StateIndex:=0 else CV.cdItem.StateIndex:=1;
      end else
      begin
        if(CV.parent<>nil)then
        begin
          if(CV.parent.achild[High(CV.parent.achild)] = CV)then
          CV.cdItem.StateIndex:=3 else CV.cdItem.StateIndex:=2;
        end;
      end;
    end else//3
    begin
      CV.cdItem.Caption:=CV.idd.iname;
      CV.cdItem.StateIndex:=-1;
      CV.cdItem.Indent:=0;
    end;
    Inc(i);
    CV.cdItem.Data:=CV;
    if(CV.idd.ntype = ntFile)then
    CV.cdItem.ImageIndex:=17
    else
    CV.cdItem.ImageIndex:=16;
    if(CV.dirfrom<>nil)then
    CV.cdItem.SubItems.Strings[0]:=CV.dirfrom.dname
    else
    CV.cdItem.SubItems.Strings[0]:='Error!!!';

    CV.cdItem.SubItems.Strings[1]:=CV.dirto.dname;
    if(CV.idd.actionindex = aiRenameTo)and(CV.idd.ifs<>'')then
    CV.cdItem.SubItems.Strings[1]:=CV.idd.ifs;
    //CV.cdItem.SubItemImages[1]:=CV.istate;
    if(CV.icause>0)then
    CV.cdItem.SubItemImages[0]:=CV.icause+18
    else
    CV.cdItem.SubItemImages[0]:=-1;
    
    if(CV.current)then
    CV.cdItem.SubItemImages[1]:=39
    else
    CV.cdItem.SubItemImages[1]:=CV.istate;

    CV.cdItem.SubItems.Strings[2]:=SizeString(CV.idd.isize);
    case CV.iResult of
      tiExecErr: CV.cdItem.SubItemImages[2]:=34;
      tiExecOK : CV.cdItem.SubItemImages[2]:=33;
      tiExecAbort: CV.cdItem.SubItemImages[2]:=35;
      else
      CV.cdItem.SubItemImages[2]:=-1;
    end;

    
    if(CV.idd.ntype = ntDir)then
    begin
      CV.cdItem.SubItems.Strings[3]:=DateToStr(CV.idd.timecreate);
      CV.cdItem.SubItems.Strings[4]:=TimeToStr(CV.idd.timecreate);
    end else
    begin
        case ff.TempJ.TP.iDateType of
          0: //Each his own
          begin
            CV.cdItem.SubItems.Strings[3]:=DateToStr(CV.idd.timewrite);
            CV.cdItem.SubItems.Strings[4]:=TimeToStr(CV.idd.timewrite);
          end;
          1: //Time Create
          begin
            CV.cdItem.SubItems.Strings[3]:=DateToStr(CV.idd.timecreate);
            CV.cdItem.SubItems.Strings[4]:=TimeToStr(CV.idd.timecreate);
          end;
          2: //Time Access
          begin
            CV.cdItem.SubItems.Strings[3]:=DateToStr(CV.idd.timeaccess);
            CV.cdItem.SubItems.Strings[4]:=TimeToStr(CV.idd.timeaccess);
          end;
          3: //Time Write
          begin
            CV.cdItem.SubItems.Strings[3]:=DateToStr(CV.idd.timewrite);
            CV.cdItem.SubItems.Strings[4]:=TimeToStr(CV.idd.timewrite);
          end;
        end;
    end;
    CV.cdItem.SubItems.Strings[5]:=IntToStr(i);
  end;
  j:=ff.iTo-ff.iFrom;
  while j < ff.LVDSync.Items.Count do
  begin
  if(ff.showstop)then
    begin
    ff.showstop:=false;
    exit;
    end;
  TL:=ff.LVDSync.Items.Item[j];
  if(TL.Data<>nil)then
  begin
    cc:=CompData(TL.Data);
    cc.cdItem:=nil;
    if(j>sss-1)then
    begin
      TL.Delete;
      continue;
    end;
  end;
  TL.Data:=nil;
  Inc(j);
  TL.Caption:='';
  TL.Indent:=0;
  TL.Selected:=false;
  TL.ImageIndex:=-1;
  TL.StateIndex:=-1;
  TL.SubItems.Strings[0]:='';
  TL.SubItems.Strings[1]:='';
  TL.SubItems.Strings[2]:='';
  TL.SubItems.Strings[3]:='';
  TL.SubItems.Strings[4]:='';
  TL.SubItems.Strings[5]:='';
  TL.SubItemImages[0]:=-1;
  TL.SubItemImages[1]:=-1;
  TL.SubItemImages[2]:=-1;
  end;
  ff.SB.Panels.Items[2].Text:='  Filtered: '+IntToStr(ff.TempJ.LFTop.Count);
except
FormLog.RecError('2003');
end;
end;

procedure TFormGrSync.TBDefaultClick(Sender: TObject);
var
i: integer;
begin
  try
    TempJ.SetDefFilters;
    for i:=0 to 5 do
    begin
      LVDSync.Columns.Items[i].ImageIndex:=13;
      LVDSync.Columns.Items[i].Tag:=0;
    end;
    TempJ.LFTop.Clear;
    TempJ.LFTop.Assign(TempJ.LTop);
    ShowRecTh(slcFirst);
  except
  //
  end;
end;

procedure TFormGrSync.TBFirstClick(Sender: TObject);
var
rr: TRect;
begin
try
  TempJ.CheckDefaultFilters;
    if(TToolButton(Sender).Name = 'TBFirst')then
    begin
      if(not TBShowAllF.Down)then
      ShowRecTh(slcFirst)
      else
      begin
        if(LVDSync.Items.Count>0)then
        LVDSync.Items.Item[0].MakeVisible(false);
      end;
    end else
    if(TToolButton(Sender).Name = 'TBLast')then
    begin
      if(not TBShowAllF.Down)then
      ShowRecTh(slcLast)
      else
      begin
        if(LVDSync.Items.Count>0)then
        LVDSync.Items.Item[LVDSync.Items.Count-1].MakeVisible(false);
      end;
    end else
    if(TToolButton(Sender).Name = 'TBPrevI')then
    begin
      if(not TBShowAllF.Down)then
      ShowRecTh(slcBack)
      else
      begin
        rr:=LVDSync.TopItem.DisplayRect(drBounds);
        LVDSync.Scroll(0,(rr.Top-rr.Bottom));
      end;
    end else
    if(TToolButton(Sender).Name = 'TBBack')then
    begin
      if(not TBShowAllF.Down)then
      ShowRecTh(slcBBack)
      else
      begin
        rr:=LVDSync.TopItem.DisplayRect(drBounds);
        LVDSync.Scroll(0,(rr.Top-rr.Bottom)*LVDSync.VisibleRowCount);
      end;
    end else
    if(TToolButton(Sender).Name = 'TBNextI')then
    begin
      if(not TBShowAllF.Down)then
      ShowRecTh(slcNext)
      else
      begin
        rr:=LVDSync.TopItem.DisplayRect(drBounds);
        LVDSync.Scroll(0,(rr.Bottom-rr.Top));
      end;
    end else
    if(TToolButton(Sender).Name = 'TBNext')then
    begin
      if(not TBShowAllF.Down)then
      ShowRecTh(slcNNext)
      else
      begin
        rr:=LVDSync.TopItem.DisplayRect(drBounds);
        LVDSync.Scroll(0,(rr.Bottom-rr.Top)*LVDSync.VisibleRowCount);
      end;
    end;
except
//
end;
end;

procedure TFormGrSync.SBDrawPanel(StatusBar: TStatusBar;
  Panel: TStatusPanel; const Rect: TRect);
begin
try
if(Panel.Index = 0)then
begin
//if(TempJ<>nil)then StatusBar.Canvas.TextOut(0,4,TempJ.StageStr);
end;
except
//
end;
end;

procedure TFormGrSync.TBShowAllFClick(Sender: TObject);
begin
try
if(TBShowAllF.Down)then
  begin
   ShowRecTh(slcFiltered);
  end else
  begin
    ShowRecTh(slcFirst);
  end;
except
//
end;
end;

procedure TFormGrSync.ShowRecTh(showmode: integer;flag: integer=1);
begin
try
  if(ASTH<>nil)then
  begin
  exit;
  end;
  ASTH:=SyncATh.Create(true);
  ASTH.GS:=self;
  ASTH.flag:=flag;
  ASTH.showmode:=showmode;
  ASTH.Resume;
except
//
end;
end;

procedure TFormGrSync.TBInvertClick(Sender: TObject);
var
i: integer;
begin
try
  for i:=0 to LVDSync.Items.Count-1 do
  begin
  LVDSync.Items.Item[i].Selected:=not LVDSync.Items.Item[i].Selected;
  end;
  LVDSync.SetFocus;
except
//
end;
end;

procedure TFormGrSync.Timer1Timer(Sender: TObject);
begin
try
  if(bShutDownAll)or(TempJ = nil)or(TempJ.babort)then
  begin
    Timer1.Enabled:=false;
    exit;
  end;
  if(TempJ.position >= TempJ.maxval)then
  TempJ.position:=0;
  if(TempJ.position2 >= TempJ.maxval2)then
  TempJ.position2:=0;
  Gauge1.MaxValue:=TempJ.maxval;
  Gauge1.Progress:=TempJ.position;
  Gauge2.MaxValue:=TempJ.maxval2;
  Gauge2.Progress:=TempJ.position2;

  if(TempJ.RDR.requestflag)then InvokeDlg(TempJ);

  if(GGG<>nil)then
  begin
    if(not GGG.Suspended)then
    begin
      tvalue:=tval2+(Now - tstart);
      if(TBExPrev.Enabled)or(TBExNext.Enabled)then
      begin
      TBExPrev.Enabled:=false;
      TBExNext.Enabled:=false;
      end;
    end else
    begin
      if(TempJ.CycleVar > 0)and(not TBExPrev.Enabled)then
      TBExPrev.Enabled:=true;
      if(TempJ.CycleVar < TempJ.LTop.Count-1)and(not TBExNext.Enabled)then
      TBExNext.Enabled:=true;
      tval2:=tvalue;
      tstart:=Now;
    end;
  end;
        
  LElapsed.Caption:=TimeToStr(tvalue);
  LItems.Caption:=IntToStr(LVDSync.Items.Count)+' / '+IntToStr(TempJ.LFTop.Count);
except
  FormLog.RecError('0004'+ mmFatalError);
  Timer1.Enabled:=false;
end;
end;

procedure TFormGrSync.LVDSyncColumnClick(Sender: TObject;
  Column: TListColumn);
begin
try
  if(Column.Index = 6)then exit;
  Column.ImageIndex:=14+Column.Tag;
  Column.Tag:=Column.Tag+1;
  if(Column.Tag = 2)then Column.Tag:=-1;
  TempJ.ManTopCol(Column,AssignColumns(Column.Index));
  if(TBAuto.Down)then ShowRecTh(slcFiltered,2);
except
//
end;
end;

function TFormGrSync.AssignColumns(ColInd: integer): integer;
begin
  Result:=0;
  case ColInd of
    0:Result:=1;
    1:Result:=13;
    2:Result:=14;
    3:Result:=3;
  end;
  case TempJ.TP.iDateType of
    0:
    begin
      case ColInd of
        4:Result:=11;
        5:Result:=12;
      end;
    end;//Each his own
    1:
    begin
      case ColInd of
        4:Result:=4;
        5:Result:=5;
      end;
    end;//Time Create
    2:
    begin
      case ColInd of
        4:Result:=6;
        5:Result:=7;
      end;
    end;//Time Access
    3:
    begin
      case ColInd of
        4:Result:=8;
        5:Result:=9;
      end;
    end;//Time Write
  end;
end;

procedure TFormGrSync.ColumnSort;
begin
try
  TempJ.CheckDefaultFilters;
  FilterSync;
  TempJ.SortList(lnLFTop,siCompData);
  if(TBShowAllF.Down)then
  ShowSyncRecords(slcFiltered)
  else
  ShowSyncRecords(slcFirst);
except
//
end;
end;

procedure TFormGrSync.TBSortClick(Sender: TObject);
begin
try
  if(TToolButton(Sender).Name = 'TBSuccess')then
  TempJ.TP.iResult:=1 else
  if(TToolButton(Sender).Name = 'TBFailure')then
  TempJ.TP.iResult:=2 else
  if(TToolButton(Sender).Name = 'TBAbort')then
  TempJ.TP.iResult:=3;
  TempJ.CheckDefaultFilters;
  FilterSync;
  if(TBSort.Down)then
  begin
    ShowRecTh(slcFiltered,2);
  end else
  begin
    sortstop:=true;
    TempJ.position:=0;
  end;
except
//
end;
end;

procedure TFormGrSync.TBShowFilterClick(Sender: TObject);
begin
InvokeFilters(TempJ,lnLTemp,2,TBShowAllF,TBIco,LVDSync);
end;

procedure TFormGrSync.LVDSyncAdvancedCustomDrawItem(
  Sender: TCustomListView; Item: TListItem; State: TCustomDrawState;
  Stage: TCustomDrawStage; var DefaultDraw: Boolean);
var
tt: TColor;
begin
try
if(TBColors.Down)then
begin
tt:=FormLog.GetExtColor(ExtractFileExt(Item.Caption));
if(tt<>clBlack)then
Sender.Canvas.Brush.Color:=tt;
end;
if(TBIco.Down)then
ShowWinIcons2(Item,ico);
DefaultDraw:=true;
except
//
end;
end;

procedure TFormGrSync.TBColorsClick(Sender: TObject);
begin
LVDSync.Refresh;
end;

procedure TFormGrSync.TBShowMClick(Sender: TObject);
begin
ListMenuClick(LVDSync,TToolButton(Sender).ImageIndex);
end;

procedure TFormGrSync.ListMenuClick(LVDSync: TListView;imgindex: integer);
var
TL: TListItem;
i: integer;
CV: CompData;
dd: IDRec;
sel: TList;
begin
  sel:= TList.Create;
  try
  try
  dd:=nil;
  if(TempJ.LFTop.Count = 0)then exit;
  if(TBAssign.Down)then
  begin
    if(imgindex = aiCopyTo)or(imgindex = aiMoveTo)or(imgindex = aiMoveContentTo)then
    if(InvokeDirDialog(dd,true) = '')then
    exit;

    if(imgindex = aiRenameTo)then
    begin
    for i:=0 to LVDSync.Items.Count-1 do
    sel.Add(CompData(LVDSync.Items.Item[i].Data).idd);
    if(not InvokeRename(sel))then
    exit;
    end;

    for i:=0 to TempJ.LFTop.Count-1 do
    begin
      CV:= CompData(TempJ.LFTop.Items[i]);
      if(CV.idd.ntype = ntFile)and((imgindex = aiEmpty)or(imgindex = aiEmptyToRecycle)or
      (imgindex = aiMoveContentTo))then
      continue;
      CalcSpace(CV,imgindex,dd);
      CV.istate:=imgindex;
      if(CV.cdItem<>nil)then
      begin
        TL:=CV.cdItem;
        CV.cdItem.SubItemImages[1]:=imgindex;
        case imgindex of
          aiShow: TL.SubItems.Strings[1]:=tsShow;
          aiMoveToRecycle: TL.SubItems.Strings[1]:=tsMoveToRecycle;
          aiDelete: TL.SubItems.Strings[1]:=tsDelete;
          aiCopyTo:   TL.SubItems.Strings[1]:=CV.dirto.dname;
          aiMoveTo:   TL.SubItems.Strings[1]:=CV.dirto.dname;
          aiRenameTo: TL.SubItems.Strings[1]:=CV.idd.ifs;
          aiEmpty: TL.SubItems.Strings[1]:=tsEmpty;
          aiEmptyToRecycle: TL.SubItems.Strings[1]:=tsEmptyToRecycle;
          aiMoveContentTo: TL.SubItems.Strings[1]:=CV.dirto.dname;
        end;
      end;
    end;
  end else
  begin
  ////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////////////
      if(imgindex = aiCopyTo)or(imgindex = aiMoveTo)or(imgindex = aiMoveContentTo)then
      if(InvokeDirDialog(dd,true) = '')then
      exit;

      if(imgindex = aiRenameTo)then
      begin
        for i:=0 to LVDSync.Items.Count-1 do
        if(LVDSync.Items.Item[i].Selected)then
        sel.Add(CompData(LVDSync.Items.Item[i].Data).idd);
        if(not InvokeRename(sel))then
        exit;
      end;
    for i:=0 to LVDSync.Items.Count-1 do
    begin
      TL:=LVDSync.Items.Item[i];
      if(not TL.Selected)then continue;
      CV:= CompData(TL.Data);
      if(CV.idd.ntype = ntFile)and((imgindex = aiEmpty)or(imgindex = aiEmptyToRecycle)or
      (imgindex = aiMoveContentTo))then continue;
      CalcSpace(CV,imgindex,dd);
      CV.istate:=imgindex;
      TL.SubItemImages[1]:=imgindex;
    case imgindex of
      aiShow: TL.SubItems.Strings[1]:=tsShow;
      aiMoveToRecycle: TL.SubItems.Strings[1]:=tsMoveToRecycle;
      aiDelete: TL.SubItems.Strings[1]:=tsDelete;
      aiCopyTo:   TL.SubItems.Strings[1]:=CV.dirto.dname;
      aiMoveTo:   TL.SubItems.Strings[1]:=CV.dirto.dname;
      aiRenameTo: TL.SubItems.Strings[1]:=CV.idd.ifs;
      aiEmpty: TL.SubItems.Strings[1]:=tsEmpty;
      aiEmptyToRecycle: TL.SubItems.Strings[1]:=tsEmptyToRecycle;
      aiMoveContentTo: TL.SubItems.Strings[1]:=CV.dirto.dname;
    end;
    end;
  end;
  ShowDisks;
  finally
  sel.Free;
  end;
  except
  //
  end;
end;

procedure TFormGrSync.PopupTopPopup(Sender: TObject);
var
i,pos: integer;
cc: CompData;
begin
try
cc:=CompData(LVDSync.Selected.Data);
  if(cc<>nil)and(cc.idd.ntype = ntFile)then
  begin
    if(cc.parent<>nil)and(cc.parent.istate in EnNoChangeChildren)then
    pos:=0 else pos:=aiEmpty;
    for i:=pos to PopupTop.Items.Count-1 do
    PopupTop.Items.Items[i].Enabled:=false;
  end else
  begin
    if(cc.parent<>nil)and(cc.parent.istate in EnNoChangeChildren)then
    begin
    for i:=0 to PopupTop.Items.Count-1 do
    PopupTop.Items.Items[i].Enabled:=false;
    end else
    for i:=0 to PopupTop.Items.Count-1 do
    PopupTop.Items.Items[i].Enabled:=true;
    if(cc<>nil)and(not cc.idd.explored)then
    begin
      for i:=0 to PopupTop.Items.Count-1 do
      if(i in EnDirNeedExplore)then
      PopupTop.Items.Items[i].Enabled:=false;
    end;
  end;
  except
//
end;
end;

function TFormGrSync.FindRootDir(ddir: string): TDList;
var
i: integer;
LVI: TDList;
begin
Result:=nil;
try
  for i:=0 to Tempj.LItems.Count-1 do
  begin
    LVI:= TDList(Tempj.LItems.Items[i]);
    if(LVI.DPar.dname = ddir)then
    begin
      Result:=LVI;
      break;
    end;
  end;
except
//
end;
end;

procedure TFormGrSync.CalcSpace(CV: CompData;newindex: integer;dd: IDRec;LD: TDList=nil);
var
cn: CompData;
sum: real;
num,dtype,i: integer;
OLD,LVD: TDList;
begin
try
sum:=0;
LVD:=LD;
dtype:=dtShow;
if(LVD = nil)then
begin
  case newindex of
    aiShow           : dtype:=dtShow;
    aiMoveToRecycle  : dtype:=dtRecycle;
    aiDelete         : dtype:=dtDelete;
    aiCopyTo         : dtype:=dtDir;
    aiMoveTo         : dtype:=dtDir;
    aiRenameTo       : dtype:=dtRename;
    aiEmpty          : dtype:=dtDelete;
    aiEmptyToRecycle : dtype:=dtRecycle;
    aiMoveContentTo  : dtype:=dtDir;
  end;
  //if(newindex in EnStdTypes)then
  if(dtype <> dtDir)then
  begin
    LVD:=FindRootDir(StdTypesArr[newindex]);
    if(LVD = nil)then
    begin
      LVD:= TDList.Create;
      TempJ.LItems.Add(LVD);
      LVD.DPar.itype:=dtype;
      LVD.DPar.rj:=TempJ;
      LVD.DPar.dname:=StdTypesArr[newindex];
      LVD.DPar.groupname:='...';
      LVD.DPar.Disk.disk:=StdTypesArr[newindex];
    end;
  end else
  begin
    if(dd = nil)then exit;
    LVD:=FindRootDir(dd.ilabel);
    if(LVD = nil)then
    begin
      LVD:= TDList.Create;
      TempJ.LItems.Add(LVD);
      LVD.DPar.itype:=dtype;
      LVD.DPar.dname:=dd.ilabel;
      LVD.DPar.groupname:='...';
      LVD.DPar.rj:=dd.rj;
      LVD.DPar.Disk.disk:=ExtractFileDrive(dd.ilabel);
    end;
  end;
end;
  OLD:=TDList(CV.dirto.pTDList);
    num:=1;
    if(CV.idd.ntype = ntDir)then
    begin
      for i:=0 to High(CV.achild)do
      begin
        cn:=CV.achild[i];
        if(cn.achild<>nil)then
        CalcSpace(cn,newindex,nil,LVD)
        else begin
        sum:=sum+cn.idd.isize;
        num:=num+1;
        end;
        if(cn.cdItem<>nil)then
        begin
          cn.cdItem.SubItemImages[1]:= newindex;
          case newindex of
            aiShow          : cn.cdItem.SubItems.Strings[1]:=tsShow;
            aiMoveToRecycle : cn.cdItem.SubItems.Strings[1]:=tsMoveToRecycle;
            aiDelete        : cn.cdItem.SubItems.Strings[1]:=tsDelete;
            aiCopyTo        : cn.cdItem.SubItems.Strings[1]:=LVD.DPar.dname;
            aiMoveTo        : cn.cdItem.SubItems.Strings[1]:=LVD.DPar.dname;
            aiRenameTo      : cn.cdItem.SubItems.Strings[1]:=CV.idd.ifs;
            aiEmpty         : cn.cdItem.SubItems.Strings[1]:=tsEmpty;
            aiEmptyToRecycle: cn.cdItem.SubItems.Strings[1]:=tsEmptyToRecycle;
            aiMoveContentTo : cn.cdItem.SubItems.Strings[1]:=LVD.DPar.dname;
          end;
        end;
        cn.dirto:=@LVD.DPar;
        cn.istate:=newindex;
      end;
    end else sum:=CV.idd.isize;
    LVD.DPar.Disk.required:= LVD.DPar.Disk.required + sum;
    LVD.DPar.Disk.items:=LVD.DPar.Disk.items+num;
    OLD.DPar.Disk.required:= OLD.DPar.Disk.required - sum;
    OLD.DPar.Disk.items:=OLD.DPar.Disk.items-num;
    CV.istate:=newindex;
    CV.dirto:=@LVD.DPar;
except
//
end;
end;

procedure TFormGrSync.Show1Click(Sender: TObject);
begin
ListMenuClick(LVDSync,TMenuItem(Sender).ImageIndex);
end;

procedure TFormGrSync.LVDSyncClick(Sender: TObject);
var
CV: CompData;
KL: TListItem;
rr: TRect;
begin
try
  KL:=LVDSync.GetItemAt(Lpp.X,Lpp.Y);
  if(KL<>nil)and(KL.Data<>nil)then
  begin
  rr:=KL.DisplayRect(drIcon);
  rr.Left:=rr.Left-16;
  rr.Right:=rr.Right-16;
  if(MatchesRect(Lpp,rr))then
  begin
    CV:=CompData(KL.Data);
    CV.expanded:=not CV.expanded;
    if(not CV.expanded)then CollapseChild(CV);
    if(TBShowAllF.Down)then
    ShowRecTh(slcFiltered)
    else
    ShowRecTh(slcCurrent);
    end;
  end;
except
//
end;
end;

procedure TFormGrSync.CollapseChild(CV: CompData;iscollapse: boolean = false);
var
i: integer;
begin
try
  for i:=0 to High(CV.achild)do
  begin
    CV.achild[i].expanded:=iscollapse;
    if(CV.achild[i].achild<>nil)then
    CollapseChild(CV.achild[i],iscollapse);
  end;
except
//
end;
end;

procedure TFormGrSync.TBCollapseClick(Sender: TObject);
var
i: integer;
cc: boolean;
begin
try
  if(TBCollapse.Tag = 0)then
  begin
  cc:=true;
  TBCollapse.Tag:=1;
  end else
  begin
  cc:=false;
  TBCollapse.Tag:=0;
  end;
  for i:=0 to TempJ.LTop.Count-1 do
  if(CompData(TempJ.LTop.Items[i]).parent = nil)then
  begin
  CompData(TempJ.LTop.Items[i]).expanded:=cc;
  CollapseChild(CompData(TempJ.LTop.Items[i]),cc);
  end;
  if(TBShowAllF.Down)then
  ShowRecTh(slcFiltered)
  else
  ShowRecTh(slcCurrent);
except
//
end;
end;

procedure TFormGrSync.LVDSyncMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
Lpp.X:=X;
Lpp.Y:=Y;
end;

procedure TFormGrSync.LVDSyncSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
var
CV: CompData;
i: integer;
rr: IDrec;
begin
if(self.Tag = -1)then exit;
try
if(Item.Caption = '')or(Item.Data = nil)then
begin
Item.Selected:=false;
Item.Focused:=false;
CurrItem:=nil;
exit;
end;
CV:=CompData(Item.Data);
CurrItem:=CV;

MCurr.Lines.Strings[0]:=mmFrom+Item.SubItems.Strings[0]+'\'+Item.Caption;
MCurr.Lines.Strings[1]:=mmTo+Item.SubItems.Strings[1];

ETCreate.Text:=DateTimeToStr(CV.idd.timecreate);
ETCreate.Color:=clWindow;
RTCreate:=ETCreate.Text;

ETAccess.Text:=DateTimeToStr(CV.idd.timeaccess);
ETAccess.Color:=clWindow;
RTAccess:=ETAccess.Text;

ETWrite.Text:=DateTimeToStr(CV.idd.timewrite);
ETWrite.Color:=clWindow;
RTWrite:=ETWrite.Text;

ESize.Text:=SizeString(CV.idd.isize)+'  ( '+ FormatNumber(FloatToStr(CV.idd.isize))+' bytes )';
/////////////////////
if(CV.idd.ntype = ntDir)then
begin
if(CV.ilevel = 0)then
LNum.Caption:=fsFiles+' : '+IntToStr(TDList(CV.dirfrom.pTDList).ifiles)+
'  '+fsFolders+' : '+ IntToStr(TDList(CV.dirfrom.pTDList).ifolders)
else
LNum.Caption:=fsFiles+' : 0'+'  '+fsFolders+' : 0';
end;
rr:=CV.idd;
if((rr.iattr and faReadOnly)<> 0)then LVAttr.Items.Item[0].Checked:=true else
    LVAttr.Items.Item[0].Checked:=false;

    if((rr.iattr and faHidden)<> 0)then LVAttr.Items.Item[1].Checked:=true else
    LVAttr.Items.Item[1].Checked:=false;

    if((rr.iattr and faSysFile)<> 0)then LVAttr.Items.Item[2].Checked:=true else
    LVAttr.Items.Item[2].Checked:=false;

    if((rr.iattr and faVolumeID)<> 0)then LVAttr.Items.Item[3].Checked:=true else
    LVAttr.Items.Item[3].Checked:=false;

    if((rr.iattr and faDirectory)<> 0)then LVAttr.Items.Item[4].Checked:=true else
    LVAttr.Items.Item[4].Checked:=false;

    if((rr.iattr and faArchive)<> 0)then LVAttr.Items.Item[5].Checked:=true else
    LVAttr.Items.Item[5].Checked:=false;
    LVAttr.Color:=clWindow;

    BApply.Enabled:=false;
//////////////////////
  {
    if(CV<>nil)and(CV.parent<>nil)and(CV.parent.istate in EnNoChangeChildren)then
    begin
    for i:=0 to ToolBar6.ButtonCount-3 do
    ToolBar6.Buttons[i].Enabled:=false;
    end else
    for i:=0 to ToolBar6.ButtonCount-3 do
    ToolBar6.Buttons[i].Enabled:=true;
    //////////////////////////////
  }
    if(CV<>nil)and(CV.idd.ntype = ntDir)and(not CV.idd.explored)then
    begin
      for i:=0 to ToolBar6.ButtonCount-3 do
      if(ToolBar6.Buttons[i].ImageIndex in EnDirNeedExplore)then
      ToolBar6.Buttons[i].Enabled:=false;
    end;
except
FormLog.RecError('2006');
end;
end;

procedure TFormGrSync.FormDestroy(Sender: TObject);
begin
try
ico.Free;
GrSyncFormList.Delete(GrSyncFormList.IndexOf(self));
self.Tag:=-1;
  sortstop:=true;
  showstop:=true;
  if(GGG<>nil)then
  begin
  if(TempJ <> nil)then TempJ.babort:=true;
  GGG.Resume;
  GGG:=nil;
  end;
  if(ASTH<>nil)then
  begin
  ASTH.Resume;
  ASTH:=nil;
  end;
except
FormLog.RecError('2007');
end;
end;

procedure TFormGrSync.TBIcoClick(Sender: TObject);
var
i: integer;
CV: CompData;
begin
try
  if(TBIco.Down)then
  begin
  for i:=0 to LVDSync.Items.Count-1 do
  ShowWinIcons2(LVDSync.Items.Item[i],ico);
  end else
  for i:=0 to LVDSync.Items.Count-1 do
  begin
    CV:=CompData(LVDSync.Items.Item[i].Data);
    if(CV = nil)then continue;
    if(CV.idd.ntype = ntFile)then
    LVDSync.Items.Item[i].ImageIndex:=17
    else
    LVDSync.Items.Item[i].ImageIndex:=16;
  end;
  LVDSync.Refresh;
except
//
end;
end;

procedure TFormGrSync.TBSkipClick(Sender: TObject);
begin
try
if(TempJ<>nil)then
TempJ.bskip:=true;
except
//
end;
end;

procedure TFormGrSync.CBErrStopClick(Sender: TObject);
begin
try
if(TempJ<>nil)then
TempJ.StopOnError:=CBErrStop.Checked;
except
//
end;
end;

procedure TFormGrSync.CBERetryChange(Sender: TObject);
begin
try
if(TempJ<>nil)then
TempJ.RetryIndex:=CBERetry.ItemIndex;
except
//
end;
end;

procedure TFormGrSync.CBCloseClick(Sender: TObject);
begin
try
if(TempJ<>nil)then
TempJ.CloseIfNoError:=CBClose.Checked;
except
//
end;
end;

procedure TFormGrSync.TBProp1Click(Sender: TObject);
begin
if(TBProp1.Down)then
PProp.Height:=65
else
PProp.Height:=0;
end;

procedure TFormGrSync.LVAttrChange(Sender: TObject; Item: TListItem;
  Change: TItemChange);
begin
BApply.Enabled:=true;
LVAttr.Color:=clYellow;
end;

procedure TFormGrSync.BApplyClick(Sender: TObject);
var
i: integer;
tcreate,taccess,twrite,dd: TDateTime;
begin
try
  BApply.Enabled:=false;
  CurrItem.idd.iattr:=0;
  for i:=0 to 5 do
  begin
    if(LVAttr.Items.Item[i].Checked)then
    CurrItem.idd.iattr:=CurrItem.idd.iattr or FileAttr[i];
  end;
  if(CurrItem.idd.rj.SetAttr(CurrItem.idd.ilabel,CurrItem.idd.iattr) = 0)then
  LVAttr.Color:=clWindow
  else
  LVAttr.Color:=clRed;

  if(TryStrToDateTime(ETCreate.Text,dd))and(dd>0)then
  tcreate:=dd
  else
  begin
  tcreate:=StrToDateTime(RTCreate);
  ETCreate.Text:=RTCreate;
  end;
  if(TryStrToDateTime(ETAccess.Text,dd))and(dd>0)then
  taccess:=dd
  else
  begin
  taccess:=StrToDateTime(RTAccess);
  ETAccess.Text:=RTAccess;
  end;
  if(TryStrToDateTime(ETWrite.Text,dd))and(dd>0)then
  twrite:=dd
  else
  begin
  twrite:=StrToDateTime(RTWrite);
  ETWrite.Text:=RTWrite;
  end;
  if(CurrItem.idd.rj.SetDateI(CurrItem.idd.ilabel,taccess,twrite,tcreate))then
  begin
    ETCreate.Color:=clWindow;
    ETAccess.Color:=clWindow;
    ETWrite.Color :=clWindow;
    CurrItem.idd.timeaccess:=taccess;
    CurrItem.idd.timewrite :=twrite;
    CurrItem.idd.timecreate:=tcreate;
    CurrItem.cdItem.SubItems.Strings[3]:=DateToStr(twrite);
    CurrItem.cdItem.SubItems.Strings[4]:=TimeToStr(twrite);
  end else
  begin
    ETCreate.Color:=clRed;
    ETAccess.Color:=clRed;
    ETWrite.Color :=clRed;
  end;
except
//
end;
end;

procedure TFormGrSync.ETCreateKeyPress(Sender: TObject; var Key: Char);
var
dd: TDateTime;
begin
try
if(TryStrToDateTime(ETCreate.Text,dd))and(dd>0)then
begin
RTCreate:=TEdit(Sender).Text;
TEdit(Sender).Color:=clYellow;
BApply.Enabled:=true;
end;
except
//
end;
end;

procedure TFormGrSync.ETAccessKeyPress(Sender: TObject; var Key: Char);
var
dd: TDateTime;
begin
try
if(TryStrToDateTime(ETAccess.Text,dd))and(dd>0)then
begin
RTAccess:=TEdit(Sender).Text;
TEdit(Sender).Color:=clYellow;
BApply.Enabled:=true;
end;
except
//
end;
end;

procedure TFormGrSync.ETWriteKeyPress(Sender: TObject; var Key: Char);
var
dd: TDateTime;
begin
try
if(TryStrToDateTime(ETWrite.Text,dd))and(dd>0)then
begin
RTWrite:=TEdit(Sender).Text;
TEdit(Sender).Color:=clYellow;
BApply.Enabled:=true;
end;
except
//
end;
end;

procedure TFormGrSync.ETWriteChange(Sender: TObject);
begin
//BApply.Enabled:=true;
end;

procedure TFormGrSync.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  try
    if(TempJ <> nil)then
    begin
      TempJ.babort:=true;
      //TempJ.DriveExec(jmAbort);
      TempJ.DialogButton:=bmCancel;
    end;
    if(GGG<>nil)then
    begin
      GGG.Terminate;
      if(GGG.Suspended)then GGG.Resume;
      GGG:=nil;
    end;
  except
  //
  end;
end;

procedure TFormGrSync.Help3Click(Sender: TObject);
begin
InvokeHelp(self.Handle,hfSync);
end;

procedure TFormGrSync.About1Click(Sender: TObject);
begin
InvokeAbout;
end;

procedure TFormGrSync.TBExPrevClick(Sender: TObject);
var
CV: CompData;
begin
  try
if(GGG<>nil)and(GGG.Suspended)then
begin
    CV:=CompData(TempJ.LTop.Items[TempJ.CycleVar]);
    CV.current:=false;
    if(CV.cdItem<>nil)then CV.cdItem.SubItemImages[1]:=CV.istate;

    if(TempJ.CycleVar = 0)then
    begin
    TBExPrev.Enabled:=false;
    exit;
    end;

    Dec(TempJ.CycleVar);

    CV:=CompData(TempJ.LTop.Items[TempJ.CycleVar]);
    CV.current:=true;
    if(CV.cdItem<>nil)then CV.cdItem.SubItemImages[1]:=39;
    LVDSync.Refresh;
end;
except
//
end;
end;

procedure TFormGrSync.TBExNextClick(Sender: TObject);
var
CV: CompData;
begin
  try
if(GGG<>nil)and(GGG.Suspended)then
begin
    CV:=CompData(TempJ.LTop.Items[TempJ.CycleVar]);
    CV.current:=false;
    if(CV.cdItem<>nil)then CV.cdItem.SubItemImages[1]:=CV.istate;

    if(TempJ.CycleVar = TempJ.LTop.Count-1)then
    begin
    TBExNext.Enabled:=false;
    exit;
    end;

    Inc(TempJ.CycleVar);

    CV:=CompData(TempJ.LTop.Items[TempJ.CycleVar]);
    CV.current:=true;
    if(CV.cdItem<>nil)then CV.cdItem.SubItemImages[1]:=39;
    LVDSync.Refresh;
end;
  except
  //
  end;
end;

procedure TFormGrSync.ApplicationEvents1Message(var Msg: tagMSG;
  var Handled: Boolean);
begin
if(Msg.wParam = VK_RETURN)then TBStartClick(nil);
if(Msg.wParam = VK_ESCAPE)then Escape;
end;

procedure TFormGrSync.TBHidePanClick(Sender: TObject);
begin
if(PCurrent.Height = 0)then
PCurrent.Height:=40
else
PCurrent.Height:=0;
end;

procedure TFormGrSync.FilterSync;
var
i: integer;
dd: IDRec;
cc: CompData;
isadd: integer;
PL: string;
rj: RJob;
begin
try
rj:=TempJ;
  rj.LFTop.Clear;
  rj.position2:=0;
  rj.maxval2:=rj.LTop.Count;

  for i:=0 to rj.LTop.Count-1 do
  begin
    cc:=CompData(rj.LTop.Items[i]);
    rj.position2:=i;
    dd:=IDRec(cc.idd);
    isadd:=0;
    if(rj.babort)then break;
    if(dd.ntype = ntFile)then
    begin
      case rj.TP.iDateType of
        0:
        begin
          if((rj.TP.sTime = fsTime)or(TimeToStr(dd.timewrite) = rj.TP.sTime))then
          isadd:=isadd+1;
          if((rj.TP.sDate = fsDate)or(rj.TP.sDate = DateToStr(dd.timewrite)))then
          isadd:=isadd+1;
        end;
        1:
        begin
          if((rj.TP.sTime = fsTime)or(TimeToStr(dd.timecreate) = rj.TP.sTime))then
          isadd:=isadd+1;
          if((rj.TP.sDate = fsDate)or(rj.TP.sDate = DateToStr(dd.timecreate)))then
          isadd:=isadd+1;
        end;
        2:
        begin
          if((rj.TP.sTime = fsTime)or(TimeToStr(dd.timeaccess) = rj.TP.sTime))then
          isadd:=isadd+1;
          if((rj.TP.sDate = fsDate)or(rj.TP.sDate = DateToStr(dd.timeaccess)))then
          isadd:=isadd+1;
        end;
        3:
        begin
          if((rj.TP.sTime = fsTime)or(TimeToStr(dd.timewrite) = rj.TP.sTime))then
          isadd:=isadd+1;
          if((rj.TP.sDate = fsDate)or(rj.TP.sDate = DateToStr(dd.timewrite)))then
          isadd:=isadd+1;
        end;
        4:
        begin
          if((rj.TP.sTime = fsTime)or(TimeToStr(dd.timecheck) = rj.TP.sTime))then
          isadd:=isadd+1;
          if((rj.TP.sDate = fsDate)or(rj.TP.sDate = DateToStr(dd.timecheck)))then
          isadd:=isadd+1;
        end;
      end;
    end else
    begin
      if(rj.TP.iDateType = 4)then
      begin
        if((rj.TP.sTime = fsTime)or(TimeToStr(dd.timecheck) = rj.TP.sTime))then
        isadd:=isadd+1;
        if((rj.TP.sDate = fsDate)or(rj.TP.sDate = DateToStr(dd.timecheck)))then
        isadd:=isadd+1;
      end else
      begin
        if((rj.TP.sTime = fsTime)or(TimeToStr(dd.timecreate) = rj.TP.sTime))then
        isadd:=isadd+1;
        if((rj.TP.sDate = fsDate)or(rj.TP.sDate = DateToStr(dd.timecreate)))then
        isadd:=isadd+1;
      end;
    end;
      case rj.TP.iType of
      0: isadd:=isadd+1;
      1: if(dd.ntype = ntFile)then isadd:=isadd+1;
      2: if(dd.ntype = ntDir)then isadd:=isadd+1;
      3: if(dd.ntype = ntFileDel)then isadd:=isadd+1;
      4: if(dd.ntype = ntFileNew)then isadd:=isadd+1;
      5: if(dd.ntype = ntFileChg)then isadd:=isadd+1;
      6: if(dd.ntype = ntDirNew)then isadd:=isadd+1;
      7: if(dd.ntype = ntDirDel)then isadd:=isadd+1;
      end;
      PL:=dd.iname;

    if((rj.TP.sMask = '*')or(MatchesMask(PL,rj.TP.sMask)))then
    isadd:=isadd+1;
    if((rj.TP.sExt = fsExtension)or(ExtractFileExt(dd.iname) = rj.TP.sExt))then
    isadd:=isadd+1;
    //**********************************
    if((rj.TP.iAction = 0)or(rj.TP.iAction-1 = cc.istate))then
    isadd:=isadd+1;
    if((rj.TP.iResult = 0)or(rj.TP.iResult+9 = cc.iResult)or(rj.TP.iResult+21 = cc.iResult))then
    isadd:=isadd+1;
    //**********************************
    if(rj.TP.sFrom = gsFrom)or(rj.TP.sFrom = cc.dirfrom.dname)then
    isadd:=isadd+1;
    if(rj.TP.sTo = gsTo)or(rj.TP.sTo = cc.dirto.dname)then
    isadd:=isadd+1;
    
    if(isadd = 9)then
    begin
      rj.LFTop.Add(cc);
    end;
  end;
rj.filterchange:=false;
rj.position2:=0;
except
//
end;
end;

procedure TFormGrSync.Escape;
begin
  try
    if(TempJ <> nil)then
    begin
      TempJ.babort:=true;
      //TempJ.DriveExec(jmAbort);
      TempJ.DialogButton:=bmCancel;
    end;
    if(GGG<>nil)then
    begin
      GGG.Terminate;
      if(GGG.Suspended)then GGG.Resume;
      GGG:=nil;
      self.Hide;
    end else
    self.Close;
  except
  //
  end;
end;

end.
